package MotorGrafico.Estados;


import java.awt.Graphics;



public class StateMachine {	
	private static final int NUM_ESTADOS = 6;	
	private IState[] listaEstados;	
	private int estadoActual;
	
	//Constructor
	public StateMachine() {		
		inicilizar();		
	}	
	private void inicilizar() {
		crearEstados();	
	}	
	
	private void crearEstados(){
		listaEstados = new IState[NUM_ESTADOS];			
	}		
	
	//Setter estado
	public void setState(int estado){
		if(listaEstados[estadoActual] != null){
			//Avisamos al estado actual del cambio
			listaEstados[estadoActual].onChange();
		}	
		//Avisamos al estado de que le vamos a establecer
		listaEstados[estado].onSet();
		estadoActual = estado;		
	}	
	
	//Actualiza el estado actual
	public void update(){
		if(listaEstados[estadoActual] != null){
			listaEstados[estadoActual].update();
		}
		
	}
	//Renderiza el estado actual
	public void render(Graphics g){
		if(listaEstados[estadoActual] != null){
			listaEstados[estadoActual].render(g);
		}
	}	
	
}
