package MotorGrafico.GestorPrincipal;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JFrame;

import MotorGrafico.Utilidades.GestorXML;





public class VentanaPrincipal {
	
	private static final long serialVersionUID = 1L;
	
	private JFrame jFrame;
	private ControladorVentana controladorVentana;
	
	private int ancho;
	private int alto;
	private String titulo = "";
	
	//Constructor
	public VentanaPrincipal(GameCanvas game) {
		
		inicializarVariables();		
		
		//Creamos la ventana
		jFrame = new JFrame(titulo);
		
		//Aadimos el controlador
		jFrame.addWindowListener(controladorVentana);		
		jFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		//Establecemos que no se pueda modificar la ventana		
		jFrame.setResizable(false);		
		
		//La hacemos visible
		jFrame.setVisible(true);
		
		//Establecemos el tamao del panel
		Container c = jFrame.getContentPane();
		Dimension dimension = new Dimension(ancho,alto);
		c.setPreferredSize(dimension);
			
		//Aadimos el panel del juego y iniciamos el juego
		c.add(game,BorderLayout.CENTER);
		jFrame.pack();		
		game.iniciarJuego();	
		
		//Centramos la ventana
		jFrame.setLocationRelativeTo(null);
	}
	
	private void inicializarVariables() {
		controladorVentana = new ControladorVentana();		
		//Cargamos las variables inciailes		
		Dimension d = GestorPrincipal.getGestorPrincipal().getDimensionPantalla();
		this.ancho = (int) d.getWidth();
		this.alto = (int) d.getHeight();
		
		String s = GestorXML.getGestorXML().obtenerValorConfiguracion("ventana", "titulo");
		titulo = s;
	}
	
	
	public void cerrarVentana(){		
		jFrame.dispose();
	}
	
	public Dimension getDimensionPantalla(){
		return new Dimension(ancho,alto);
	}
	
	private class ControladorVentana implements WindowListener{

		
		public void windowActivated(WindowEvent arg0) {
			
			
		}
		
		public void windowClosed(WindowEvent arg0) {
			
			
		}

		
		public void windowClosing(WindowEvent arg0) {
		
			
		}

		@Override
		public void windowDeactivated(WindowEvent arg0) {
			
			
		}

		@Override
		public void windowDeiconified(WindowEvent arg0) {
			
			
		}

		@Override
		public void windowIconified(WindowEvent arg0) {
			
			
		}

		@Override
		public void windowOpened(WindowEvent arg0) {
			
		}
		
	}
	
}
