package MotorGrafico.Sonido;



import javax.sound.sampled.Clip;
import javax.sound.sampled.LineEvent;
import javax.sound.sampled.LineListener;

public class GestorSonido implements LineListener{

	private static GestorSonido miGestorSonido;
	
	private boolean sonidoActivado;
	
	//Listado sonidos disponibles
	public static final int MOUSE_OVER = 0;
	public static final int CLICK = 1;
	public static final int EXPLOSION = 2;
	
	public static final int MUSICA_JUGAR = 3;
	public static final int MUSICA_GAME_OVER = 4;
	
	private Sonido musicaFondo;
	
	//Constructor
	private GestorSonido(){
		inicializar();
	}
	
	private void inicializar() {
		sonidoActivado = true;			
	}
	
	//Getter
	public static GestorSonido getGestorSonido(){
		if(miGestorSonido == null){
			miGestorSonido = new GestorSonido();
		}
		return miGestorSonido;		
	}
	
	public boolean getSonidoActivado(){
		return sonidoActivado;
	}
	
	private Sonido getSonido(int i){		
		Sonido s = null;
		if (i == MOUSE_OVER) {
			s = new Sonido("/Sonido/mouseOver.wav",this);			
			return s;
		}else if(i == CLICK){
			s = new Sonido("/Sonido/click.wav",this);			
			return s;
		}else if(i == EXPLOSION){
			s = new Sonido("/Sonido/explosion.wav",this);			
			return s;
		}
		
		return s;
	}
	
	//Cambio estado
	public void cambiarEstado(){		
		sonidoActivado = !sonidoActivado;
		if(sonidoActivado == false){
			detenerMusica();
		}
	}
	
	public void ponerMusica(int i){
		if(sonidoActivado){
			detenerMusica();
			if(i == MUSICA_JUGAR){
				musicaFondo = new Sonido("/Sonido/gameMusic.wav",this);	
				musicaFondo.playLoop();
			}else if(i == MUSICA_GAME_OVER){
				musicaFondo = new Sonido("/Sonido/gameOverMusic.wav",this);	
				musicaFondo.playLoop();
			}			
		}		
	}
	
	//Para la musica
	public void detenerMusica(){
		if(musicaFondo!=null){
			musicaFondo.stop();
		}		
	}
	
	//Mtodo para poner un sonido de la lista
	public void playEfectoSonido(int i){
		try {
			//Comprobamos que este habilitado el sonido
			if(sonidoActivado){								
				getSonido(i).playOnce();							
			}		
		} catch (Exception e) {
			e.printStackTrace();
		}
		
	}
	//Avisa de eventos de sonidos cuando finalizan para cerrarlos y ahorra memoria
	public void update(LineEvent l) {
		if(l.getType() == LineEvent.Type.STOP){
			((Clip)l.getSource()).close();
		}
		
	}
}
