package MotorGrafico.Utilidades;

import java.sql.ResultSet;
import java.util.ArrayList;



public class GestorUsuarios {

	private static GestorUsuarios miGestorUsuarios;	
	private Usuario usuarioActual;	
	
	private GestorUsuarios(){
		
	}
	
	public static GestorUsuarios getGestorUsuarios(){
		if(miGestorUsuarios == null){
			miGestorUsuarios = new GestorUsuarios();
		}
		return miGestorUsuarios;
	}
	
	//Establece el usuario actual si es valido
	public boolean crearUsuarioActual(int id,String nombreUsuario){
		try {
			//Intentamos crearlo			
			usuarioActual = new Usuario(id,nombreUsuario);
			return true;
		} catch (InvalidUserException e) {
			e.printStackTrace();
			//Si da error devolvemos false
			return false;
		}		
	}
	
	//Devuelve el usuario actual
	public Usuario getUsuarioActual(){
		return usuarioActual;
	}
	
	public boolean esUsuarioActual(Usuario u){
		return usuarioActual.getIdentificador().contentEquals(u.getIdentificador());
	}	
	
}
