package Pong.ConexionServidor;
import Pong.Estados.StateMachine;
import Pong.GestorJuego.GestorPrincipal;
import Pong.Utilidades.GestorXML;


public class ControlCliente implements ClientListener {
	
	private String ip;
	private int puerto;
	
	private Client cliente;
	
	public ControlCliente() {
		//Cargamos los valores de configuracin
		GestorXML gestorXML = GestorXML.getGestorXML();
		String s = gestorXML.obtenerValorConfiguracion("servidor", "ip");
		this.ip = s;
		
		s = gestorXML.obtenerValorConfiguracion("servidor", "puerto");
		this.puerto = Integer.parseInt(s);
	}
	
	public void iniciarConexion(){		
		cliente = new Client(ip,puerto, this);		
	}	
	
	public void desconectarse(){
		cliente.dispose();
	}
	
	//Metodos para comunicarse con el servidor
	public void sendToServer(String msg){		
		cliente.send(msg);
	}	
	public void unknownHost() {			
		GestorPrincipal.getGestorPrincipal().conexionNoEstablecida();		
	}		
	public void couldNotConnect() {		
		GestorPrincipal.getGestorPrincipal().conexionNoEstablecida();	
	}		
	public void recivedInput(String msg) {		
		GestorPrincipal.getGestorPrincipal().receiveFromServer(msg);
	}		
	public void serverClosed() {		
		GestorPrincipal.getGestorPrincipal().desconectadoServidor();	
	}		
	public void disconnected() {			
		GestorPrincipal.getGestorPrincipal().desconectadoServidor();	
	}		
	public void connectedToServer() {		
		//Si hemos conectado cambiamos al estado buscando partida		
		GestorPrincipal.getGestorPrincipal().cambiarEstado(StateMachine.BUSCANDO_PARTIDA);;
	}

}
