package Pong.ControladoresEntrada;

import java.awt.Point;

public class ControladorRaton {

	//Singleton
	private static ControladorRaton miControladorRaton;
	
	
	private double posX;
	private double posY;
	private boolean clickIzquierdo;
	
	//Constructor
	private ControladorRaton() {
		inicializar();
	}
	
	private void inicializar() {
		posX = 0;
		posY = 0;
		clickIzquierdo = false;		
	}
	
	//Getters
	public static ControladorRaton getControladorRaton(){
		if(miControladorRaton == null){
			miControladorRaton = new ControladorRaton();
		}
		return miControladorRaton;
	}
	
	public boolean getClickIzquierdoPresionado(){
		return clickIzquierdo;
	}
	
	public double getPosicionX(){
		return posX;
	}
	
	public double getPosicionY(){
		return posY;
	}
	
	public Point getPosicion(){
		return new Point((int)posX,(int)posY);
	}
	//Setters
	public void setClickIzquierdo(boolean b){
		clickIzquierdo = b;
	}
	
	public void setPosicion(double x,double y){
		posX = x;
		posY = y;
	}
	
	public void actualizar(){
		setClickIzquierdo(false);
	}
	
}
