package Pong.Estados;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.util.ArrayList;

import Pong.GestorJuego.GestorPrincipal;
import Pong.InterfazUsuario.BotonInterfaz;
import Pong.InterfazUsuario.IUIListener;
import Pong.InterfazUsuario.IconoSonido;
import Pong.InterfazUsuario.Imagen;
import Pong.InterfazUsuario.Texto;
import Pong.InterfazUsuario.UIObject;
import Pong.InterfazUsuario.UIObjectInteractive;



public class EstadoInstrucciones implements IState,IUIListener {
	
	private ArrayList<UIObject> listaObjetosInterfaz;
	
	//Constructor
	public EstadoInstrucciones() {
		crearInterfaz();
	}
	
	private void crearInterfaz() {
		listaObjetosInterfaz = new ArrayList<UIObject>();
		//Creamos el fondo
		Dimension d = GestorPrincipal.getGestorPrincipal().getDimensionPantalla();			
		Imagen fondo = new Imagen(0, 0, (int)d.getWidth(),(int)d.getHeight(), "/Imagenes/background.png");
		listaObjetosInterfaz.add(fondo);
		
		//Ttulo
		Texto t = new Texto(450, 120, "INSTRUCTIONS", Texto.CENTER_ALIGNMENT, false, Color.GREEN, 60);
		listaObjetosInterfaz.add(t);
		
		//Botones
		BotonInterfaz bi = new BotonInterfaz(450, 400, "atras", "BACK",30);
		bi.addListener(this);
		listaObjetosInterfaz.add(bi);
		
		//Creamos el icono de sonido
		IconoSonido is = new IconoSonido(860, 410, "sonido", 30, 30);
		is.addListener(this);
		listaObjetosInterfaz.add(is);
		
		//Creamos la parte de controles 
		t = new Texto(30, 150, "CONTROLS", Texto.LEFT_ALIGNMENT, false, Color.orange, 30);
		listaObjetosInterfaz.add(t);
		
		Imagen i = new Imagen(30, 150, 50, 50, "/Imagenes/IconoBotonW.png");
		listaObjetosInterfaz.add(i);
		i = new Imagen(60, 150, 50, 50, "/Imagenes/IconoBotonS.png");
		listaObjetosInterfaz.add(i);
		t = new Texto(110, 185, "Move up/down", Texto.LEFT_ALIGNMENT, false, Color.WHITE, 15);
		listaObjetosInterfaz.add(t);
		
		i = new Imagen(300, 150, 50, 50, "/Imagenes/IconoBotonP.png");
		listaObjetosInterfaz.add(i);
		t = new Texto(350, 185, "Pause/Resume", Texto.LEFT_ALIGNMENT, false, Color.WHITE, 15);
		listaObjetosInterfaz.add(t);		
		
		i = new Imagen(500, 150, 50, 50, "/Imagenes/IconoBotonEsc.png");
		listaObjetosInterfaz.add(i);
		t = new Texto(550, 185, "Exit", Texto.LEFT_ALIGNMENT, false, Color.WHITE, 15);
		listaObjetosInterfaz.add(t);
		
		//Creamos la parte reglas
		t = new Texto(30, 270, "RULES", Texto.LEFT_ALIGNMENT, false, Color.orange, 30);
		listaObjetosInterfaz.add(t);
		
		t = new Texto(30, 300, "Only one pause per player allowed.", Texto.LEFT_ALIGNMENT, false, Color.white, 15);
		listaObjetosInterfaz.add(t);
		
		t = new Texto(30, 340, "If you get disconneted or exit you lose the game.", Texto.LEFT_ALIGNMENT, false, Color.white, 15);
		listaObjetosInterfaz.add(t);
		
		t = new Texto(30, 380, "First player to reach 15 points wins the game.", Texto.LEFT_ALIGNMENT, false, Color.white, 15);
		listaObjetosInterfaz.add(t);		
	}

	public void onSet() {}
	public void onChange() {}
	
	//Actualizacion interfaz
	public void update() {
		for (UIObject u1 : listaObjetosInterfaz) {
			u1.update();
		}		
	}
	//Dibujo de la interfaz
	public void render(Graphics g) {
		for (UIObject u1 : listaObjetosInterfaz) {
			u1.draw(g);
		}		
	}
	//Interaccin con botones
	public void interaccion(UIObjectInteractive object) {
		String id = object.getIdentificador();
		if(id.contentEquals("atras")){				
			GestorPrincipal.getGestorPrincipal().cambiarEstado(StateMachine.MENU_INICIO);
		}		
	}	
	
	public void receiveFromServer(String msg) {	}

}
