package Pong.GameplayObjects;

import java.awt.Color;
import java.awt.Graphics;


import Pong.Sonido.GestorSonido;
import Pong.Utilidades.GestorXML;

public class Bola {

	private double dX;
	private double posX;
	private double posY;
	private int radio;	
	
	public Bola() {
		setPos(-100, -100);
		inicializar();
	}
	
	private void inicializar() {
		//Obtenemos el radio del fichero configuracin
		String s = GestorXML.getGestorXML().obtenerValorConfiguracion("bola", "radio");
		this.radio= Integer.parseInt(s);		
	}
	
	public void setPos(double x,double y){
		this.posX = x;
		this.posY = y;
	}
	
	public void setDireccionX(double nuevaDireccion){
		//Si la direccion ha cambiado de positivo a negativo o al reves es que ha colisionado
		//Ponemos el sonido
		Boolean hayColision = ((nuevaDireccion<0) && (this.dX >0)) || ((nuevaDireccion>0) && (this.dX <0));
		if(hayColision){			
			GestorSonido gestorSonido = GestorSonido.getGestorSonido();
			gestorSonido.playEfectoSonido(GestorSonido.COLISION);
		}
		this.dX = nuevaDireccion;
	}
	//Dibuja la bola
	public void draw(Graphics g){
		g.setColor(Color.white);
		g.fillOval((int)(posX - radio), (int)(posY - radio),radio*2, radio*2);
	}

}