package Pong.InterfazUsuario;

import java.awt.Graphics;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.image.BufferedImage;
import java.io.IOException;

import javax.imageio.ImageIO;

import Pong.ControladoresEntrada.ControladorRaton;
import Pong.Sonido.GestorSonido;

public class IconoSonido extends UIObjectInteractive {
	
	private BufferedImage imagenActivado;
	private BufferedImage imagenDesactivado;
	
	private int ancho;
	private int alto;
	
	private boolean activado;	
	
	//Constructor
	public IconoSonido(double posX, double posY, String id,int ancho,int alto) {
		super(posX, posY, id);
		this.alto = alto;
		this.ancho = ancho;
		comprobarEstado();
		rectangle = new Rectangle((int)posX,(int)posY,ancho,alto);
		cargarImagenes();
		
	}
	//Carga las imagenes
	private void cargarImagenes(){
		try {
			imagenActivado = ImageIO.read(this.getClass().getResourceAsStream("/Imagenes/IconoSonidoON.png"));
			imagenDesactivado = ImageIO.read(this.getClass().getResourceAsStream("/Imagenes/IconoSonidoOFF.png"));			
		} catch (IOException e) {			
			e.printStackTrace();
		}
	}	
	
	protected void comprobarInteracion() {		
		try {
			//Si el usuario ha presionado el click izquierdo
			if(ControladorRaton.getControladorRaton().getClickIzquierdoPresionado()){
				//Obtenemos la posicin del puntero
				Point p = ControladorRaton.getControladorRaton().getPosicion();
				//Comprobamos si esta dentro			
				boolean b = rectangle.contains(p);
				if(b){
					GestorSonido.getGestorSonido().playEfectoSonido(GestorSonido.CLICK);
					//Cambiamos el estado
					cambiarEstado();
					//Avisamos al listener					
					avisarListener();
				}				
			}
		} catch (Exception e) {
			e.printStackTrace();
		}	
	}
	
	private void comprobarEstado(){
		this.activado = GestorSonido.getGestorSonido().getSonidoActivado();
	}	
	
	public void update() {
		super.update();
		comprobarEstado();
	}
	
	//Invierte el estado
	private void cambiarEstado(){
		GestorSonido.getGestorSonido().cambiarEstado();					
	}
	//Devuelve la imagen a dibujar dependiendo del estado
	private BufferedImage getImagenADibujar(){
		if (activado) {
			return imagenActivado;
		} else {
			return imagenDesactivado;
		}
	}	
	
	public void draw(Graphics g) {
		g.drawImage(getImagenADibujar(),(int)posX, (int)posY,ancho,alto,null);		
	}

}
