package Pong.Sonido;

import java.io.IOException;
import java.net.URL;

import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.sound.sampled.LineListener;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.UnsupportedAudioFileException;

public class Sonido {

	
	private Clip clip;
	
	//Constructor
	public Sonido(String path,LineListener line) {
		cargarClip(path);
		clip.addLineListener(line);
	}
	
	//Carga el sonido
	private void cargarClip(String path){
		 try {	         
	         URL url = this.getClass().getResource(path);	         
	         AudioInputStream audioInputStream = AudioSystem.getAudioInputStream(url);	        
	         clip = AudioSystem.getClip();	        
	         clip.open(audioInputStream);
	      } catch (UnsupportedAudioFileException e) {
	         e.printStackTrace();
	      } catch (IOException e) {
	         e.printStackTrace();
	      } catch (LineUnavailableException e) {
	         e.printStackTrace();
	      }		 
	}
	//Pone el sonido una unica vez
	public void playOnce(){
		//Paramos el sonido
		stop();
		//Lo volvemos a poner desde el principio
		clip.setFramePosition(0);
        clip.start();   
        
	}
	//Pone el sonido en loop hasta que se manda parar
	public void playLoop(){
		clip.loop(Clip.LOOP_CONTINUOUSLY);
	}
	//Detiene el sonido
	public void stop(){
		//Comprobamos si esta sonando
		if (clip.isRunning()){
			//Lo paramos en ese caso
			clip.stop();			
		}
	}	
}
