package Pong.Utilidades;

import java.sql.ResultSet;
import java.util.ArrayList;

import Pong.GestorJuego.GestorPrincipal;

public class GestorUsuarios {

	private static GestorUsuarios miGestorUsuarios;
	
	private Usuario usuarioActual;	
	
	private GestorUsuarios(){
//		//TODO Prueba con usuario actual
		//usuarioActual = new Usuario("USER2",800);
		//crearUsuarioActual(1, "user1");
	}
	
	public static GestorUsuarios getGestorUsuarios(){
		if(miGestorUsuarios == null){
			miGestorUsuarios = new GestorUsuarios();
		}
		return miGestorUsuarios;
	}
	
	//Establece el usuario actual si es valido
	public boolean crearUsuarioActual(int id,String nombreUsuario){
		try {
			//Intentamos crearlo			
			usuarioActual = new Usuario(id,nombreUsuario);
			return true;
		} catch (InvalidUserException e) {
			e.printStackTrace();
			//Si da error devolvemos false
			return false;
		}		
	}
	
	//Devuelve el usuario actual
	public Usuario getUsuarioActual(){
		return usuarioActual;
	}
	
	public boolean esUsuarioActual(Usuario u){
		return usuarioActual.getIdentificador().contentEquals(u.getIdentificador());
	}
	
	//Devuelve los 10 usuarios con mejor elo si los hubiera	
	public ArrayList<Usuario> getRankingUsuarios(){
		ArrayList<Usuario> listaUsuarios = new ArrayList<Usuario>();
		
		try {
			//Buscamos en la BD
			String sql = "SELECT usuario,elo FROM Ping_Pong ORDER BY elo DESC LIMIT 10;";
			ResultSet rs = GestorConexionBD.getConexionBD().consultaBD(sql);
			int indice = 0;
			//Recorremos el resultado
			while(rs.next() && indice < 10){
				//Obtenemos el usuario y lo metemos en la lista
				String usuario = rs.getString("usuario");
				int puntuacion =  rs.getInt("elo");
				Usuario u = new Usuario(usuario, puntuacion);
				listaUsuarios.add(u);
				indice++;							
			}			
			
		} catch (Exception e) {
			e.printStackTrace();
			//Avisamos del error
			GestorPrincipal.getGestorPrincipal().error("Error en la conexin a la base de datos.");
		}
		
		return listaUsuarios;	
	}
	
}
