package Pong.Utilidades;

import java.sql.ResultSet;

import Pong.GestorJuego.GestorPrincipal;

public class Usuario {

	private int id;
	private String nombreUsuario;	
	private int elo;	
	
	//Constructores
	public Usuario(int id,String nombreUsuario)throws InvalidUserException {
		
		this.nombreUsuario = nombreUsuario;
		this.id = id;
		//Lo buscamos en la BD de todos los usuarios		
		boolean existe = buscarEnBD();
		
		if(existe){
			//Buscamos en BD su mejor puntuacin
			buscarEloEnBD();	
		}else
		{			
			//Lanzamos excepcion si no existe
			throw new InvalidUserException(null);
		}
	}	
	
	public Usuario(String identificador,int elo){
		this.nombreUsuario = identificador;
		this.elo= elo;
	}	

	//Getters
	public int getElo() {
		return elo;
	}	
	
	public String getIdentificador() {
		return nombreUsuario;
	}	
	
	//Busca si este usuario esta en BD
	private boolean buscarEnBD(){
		
		String sql = "SELECT id,nombre_usuario FROM Info_Jugador WHERE nombre_usuario = '" + nombreUsuario + "'"
				+ " AND id =" + id +";";
		ResultSet rs = GestorConexionBD.getConexionBD().consultaBD(sql);
		try {
			if(rs.next()){
				return true;
			}else{
				return false;
			}					
		} catch (Exception e) {
			e.printStackTrace();
			//Avisamos del error
			GestorPrincipal.getGestorPrincipal().error("Error en la conexin a la base de datos.");
			
		}		
		return false;		
	}	
	
	//Busca en BD el elo actual del jugador	
	private void buscarEloEnBD(){
		String sql = "SELECT elo FROM Ping_Pong WHERE usuario = '" + nombreUsuario + "';";
		ResultSet rs = GestorConexionBD.getConexionBD().consultaBD(sql);
		try {
			rs.next();
			int i = rs.getInt("elo");
			this.elo = i;			
		} catch (Exception e) {
			e.printStackTrace();
			//Avisamos del error
			GestorPrincipal.getGestorPrincipal().error("Error en la conexin a la base de datos.");
		}
	}
}
