package GestionClientes;


public class Cliente {

	private DatosCliente datosCliente;
	
	private PerfilJugador perfilJugador;
	
	private String identificadorPartida;
	
	public static final int ESTADO_CONECTADO = 0;
	public static final int ESTADO_BUSCANDO = 1;
	public static final int ESTADO_ENPARTIDA = 2;
	public static final int ESTADO_DESCONECTADO = 3;
	private int estadoActual;
	
	private long tiempoInicioConexin;
	
	//Constructora
	public Cliente(String direccionIp,String puerto) {
		datosCliente = new DatosCliente(direccionIp, puerto);		
		
		//Establecemos el estado inicial
		setEstado(ESTADO_CONECTADO);
	}
	//Inicializa el perfilJugador y el tiempo de inicio de la conexin
	public void identificarse(String id){	
		tiempoInicioConexin = System.currentTimeMillis();
		perfilJugador = new PerfilJugador(id);		 
	}
	//Settes
	public void setEstado(int nuevoEstado){
		this.estadoActual = nuevoEstado;
	}
	//Setter id partida
	public void setIdentificadorPartida(String id){
		this.identificadorPartida = id;
	}	
	//Getters
	public int getEstado(){
		return estadoActual;
	}
	public String getIdentificadorPartida(){
		return identificadorPartida;
	}	
	
	public PerfilJugador getPerfilJugador(){
		return perfilJugador;
	}
	
	public long getTiempoInicioConexion(){
		return tiempoInicioConexin;
	}
	
	//Devuelve la combinacin entre ip y puerto que es nica
	public String getKey(){
		return datosCliente.getStringDatos();
	}
	
}
