package GestionClientes;

import java.util.HashMap;


import GestorPrincipal.GestorPrincipal;


public class ListaClientes {
	
	//Lista para almacenar todos los clientes conectados al servidor
	private HashMap<String,Cliente> lista;	
	
	//Constructor
	public ListaClientes() {
		inicializar();
	}

	private void inicializar() {
		this.lista = new HashMap<String,Cliente>();		
	}
	
	//Devuelve true si ya hay un usuario con el mismo identificador en la lista
	public boolean existeUsuarioEnLista(String id1,String key1){
		boolean existe = false;		
		synchronized (lista) {
			//Recorremos la lista clientes
			for (Cliente c: lista.values()) {
				String key2 = c.getKey();
				//Comprobamos que no se trate del mismo cliente que realiza la llamada
				if(!key1.contentEquals(key2)){
					//Comprobamos si es el mismo usuario
					try {
						String id2 = c.getPerfilJugador().getIdentificador();
						if(id1.contentEquals(id2)){
						   existe = true;
						   break;
					   }
					} catch (Exception e) {
						e.printStackTrace();
					}					
				}				
			}
		}
		return existe;		
	}
	
	//Mtodo para introducir un nuevo cliente
	public void introducirCliente(Cliente c){
		String key = c.getKey();
		synchronized (lista) {			
			this.lista.put(key, c);
			GestorPrincipal.getGestorPrincipal().mostrarMensaje("New client: "+key);
		}		
	}
	
	//Mtodo para eliminar un cliente
	public void clienteDesconectado(DatosCliente dc){
		//Obtenemos el cliente de la lista y cambiamos el estado a desconectado
		String key = dc.getStringDatos();
		synchronized (lista) {
			this.lista.get(key).setEstado(Cliente.ESTADO_DESCONECTADO);
			//Lo eliminamos de la lista
			this.lista.remove(key);
			GestorPrincipal.getGestorPrincipal().mostrarMensaje("Client disconnected: "+key);
		}
	}
	
	//Devuelve un cliente dado un key
	public Cliente getCliente(String key){
		synchronized (lista) {
			Cliente c = lista.get(key);
			return c;
		}
	}
}
