package Partida.GameObjets;

import Utilidades.GestorXML;

public class Marcador {

	//Puntuaciones jugadores
	private int puntuacionJugador1;
	private int puntuacionJugador2;
	
	private int puntuacionMaxima;
	
	//Constructor
	public Marcador() {
		inicializar();
	}

	private void inicializar() {
		//Iniciamos a 0 la puntuacin de ambos jugadores
		puntuacionJugador1 = 0;
		puntuacionJugador2 = 0;
		
		//Obtenemos las variables del fichero configuracin
		String p = GestorXML.getGestorXML().obtenerValorConfiguracion("marcador", "puntuacionMaxima");
		this.puntuacionMaxima = Integer.parseInt(p);		
	}
	//Devuelve la puntuacin actual dado un jugador
	public int getPuntuacionJugador(int numJugador){
		if(numJugador == 1){
			return puntuacionJugador1;
		}else
		{
			return puntuacionJugador2;
		}
	}
	
	//Devuelve true en caso de que un jugador haya alcanzado la puntuacin mxima
	public boolean hayGanador(){
		boolean b = (puntuacionJugador1 >= puntuacionMaxima) || (puntuacionJugador2 >= puntuacionMaxima);
		return b;
	}
	//Aumenta en 1 los puntos dado un jugador
	public void aumentarPuntos(int jugador){
		switch (jugador) {
		case 1:
			puntuacionJugador1++;
			break;
		case 2:
			puntuacionJugador2++;
			break;
		}
	}
	//Devuelve el ndice del jugador que ha ganado. Devuelve 0 en caso de que no haya ganador.
	public int getGanador(){
		if(puntuacionJugador1 >= puntuacionMaxima){
			return 1;
		}
		if(puntuacionJugador2 >= puntuacionMaxima){
			return 2;
		}
		return 0;
	}
	
}
