package Partida.GameObjets;

import java.awt.Dimension;

import Utilidades.GestorXML;

public class Tablero {

	//Dimensiones
	private int limiteArriba;
	private int limiteAbajo;
	private int limiteDerecha;
	private int limiteIzquierda;
	
	public static final int FUERA_DERECHA = 1;
	public static final int FUERA_IZQUIERDA = 2;
	public static final int FUERA_ARRIBA = 3;
	public static final int FUERA_ABAJO = 4;
	
	
	//Constructor
	public Tablero() {
		inicializar();
	}

	private void inicializar() {
		//Cargamos los valores del fichero configuracin
		String limite =  GestorXML.getGestorXML().obtenerValorConfiguracion("tablero", "limiteArriba");
		this.limiteArriba = Integer.parseInt(limite);
		
		limite =  GestorXML.getGestorXML().obtenerValorConfiguracion("tablero", "limiteAbajo");
		this.limiteAbajo = Integer.parseInt(limite);
		
		limite =  GestorXML.getGestorXML().obtenerValorConfiguracion("tablero", "limiteDerecha");
		this.limiteDerecha = Integer.parseInt(limite);
		
		limite =  GestorXML.getGestorXML().obtenerValorConfiguracion("tablero", "limiteIzquierda");		
		this.limiteIzquierda = Integer.parseInt(limite);		
	}
	//Devuelve la dimensin del tablero
	public Dimension getDimension(){
		return new Dimension(limiteDerecha, limiteAbajo);
	}
	
	//Comprobamos si la bola esta fuera del lmite del tablero y devolvemos un cdigo 
	//que indica por que lado se ha ido
	public int bolaOutOfBounds(Bola b){
		//Obtenemos la posicin y el radio
		double x = b.getPosX();
		double y = b.getPosY();		
		double radio = b.getRadio();		
		//Comprobamos el lmite izquierda
		if( (x-radio) < limiteIzquierda){
			return FUERA_IZQUIERDA;
		}
		//Comprobamos el lmite derecha
		if( (x+radio) > limiteDerecha){
			return FUERA_DERECHA;		
		}
		//Comprobamos el lmite arriba
		if( (y-radio) < limiteArriba){
			return FUERA_ARRIBA;		
		}		
		//Comprobamos el lmite abajo
		if( (y+radio) > limiteAbajo){
			return FUERA_ABAJO;		
		}
		return 0;
	}
	
	
	
	
}
