package Servidor;

import java.io.PrintWriter;

import GestionClientes.Cliente;
import GestionClientes.DatosCliente;
import GestorPrincipal.GestorPrincipal;
import Utilidades.GestorXML;

public class ControladorServidor implements ServerListener {

	private int puerto;
	
	private Server servidor;
	
	public ControladorServidor() {
		inicializar();
	}
	
	private void inicializar() {
		//Obtenemos el puerto del fichero configuracion.xml
		String p = GestorXML.getGestorXML().obtenerValorConfiguracion("servidor","puerto");
		this.puerto = Integer.parseInt(p);
	}

	public void kickCliente(DatosCliente dc){
		try {
			String ip = dc.getIp();
			String puerto = dc.getPuerto();
			servidor.kickClient(ip, puerto);
		} catch (Exception e) {
			e.printStackTrace();
		}		
	}
	
	//Inicia el servidor en un determinado puerto
	public void iniciarServidor(){
		this.servidor = new Server(puerto, this);		
	}
	
	//Gestin de la conexin de un nuevo cliente
	public void clientConncted(String ip, String puerto, PrintWriter out) {		
		//Creamos un nuevo cliente
		Cliente c = new Cliente(ip, puerto);
		//Lo pasamos al gestor principal
		GestorPrincipal.getGestorPrincipal().clienteConectado(c);		
	}

	//Gestin de la desconexin de un cliente
	public void clientDisconnected(String ip, String puerto) {
		System.out.println("Cliente desconectado");
		//Creamos una instancia de DatosCliente
		DatosCliente dc = new DatosCliente(ip, puerto);
		//Lo pasamos al gestor principal
		GestorPrincipal.getGestorPrincipal().clienteDesconectado(dc);
	}

	//Gestin de mensajes que envian los clientes
	public void recivedInput(String ip, String puerto, String msg,
			PrintWriter out) {
		//Creamos una instancia de DatosCliente
		DatosCliente dc = new DatosCliente(ip, puerto);
		//Lo pasamos al gestor principal
		GestorPrincipal.getGestorPrincipal().mensajeCliente(dc, msg, out);
		
	}

	//Gestin del cierre del servidor
	public void serverClosed() {
		
		
	}

}
