package Servidor;


import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketException;
import java.net.UnknownHostException;
import java.util.ArrayList;

/** Extraido de GitHub
 * Link: https://github.com/TheDudeFromCI/WraithEngine/tree/
 * 5397e2cfd75c257e4d96d0fd6414e302ab22a69c/WraithEngine/src/wraith/library/Multiplayer
 * Autor: https://github.com/TheDudeFromCI
 **/

public class Server{
	private int port;
	private boolean open = true;
	private ServerSocket ss;
	private ServerListener serverListener;
	private ArrayList<Socket> clients = new ArrayList<>();
	//Constructor servidor
	public Server(int port, ServerListener listener){
		serverListener=listener;
		try{
			//Creamos el servidor en un determinado puerto
			ss=new ServerSocket(port);
			if(this.port==0)this.port=ss.getLocalPort();
			else this.port=port;
			//Creamos un nuevo thread para que trabaje el servidor
			Thread serverThread = new Thread(new Runnable(){
				public void run(){					
					//Mientras el servidor este abierto
					while(open){
						try{
							//Cuando entra un nuevo cliente al servidor
							@SuppressWarnings("resource")final Socket s = ss.accept();
							//Creamos un nuevo thread para mantener la comunicacin con el cliente
							Thread clientThread = new Thread(new Runnable(){
								public void run(){
									try{
										//Aadimos el socket del cliente a la lista y obtenermos sus datos
										clients.add(s);
										BufferedReader in = new BufferedReader(new InputStreamReader(s.getInputStream()));
										PrintWriter out = new PrintWriter(s.getOutputStream(), true);
										String ip = s.getInetAddress().toString();
										String puerto = String.valueOf(s.getPort());
										//Avisamos al listener que se ha conectado un cliente
										serverListener.clientConncted(ip,puerto, out);
										//Mientras el servidor este abierto nos comunicamos con el cliente
										while(open){
											
											try{ 
												//Cuando llega un mensaje del cliente
												String texto = in.readLine();
												if(texto == null){
													//Si es null avisamos que el cliente se ha desconectado y cerramos la conexi con el cliente
													serverListener.clientDisconnected(ip,puerto);
													try{
														if(!s.isClosed()){
															s.shutdownOutput();
															s.close();
														}
													}catch(Exception exception){ exception.printStackTrace(); }
													clients.remove(s);
													return;												
												}else												{
													//Si contiene un mensaje se lo pasamos al listener
													serverListener.recivedInput(ip,puerto, texto, out);
												}
												
												
											}catch(IOException e){
												//Si se produce algun error cerramos la conexin con el cliente
												serverListener.clientDisconnected(ip,puerto);
												try{
													if(!s.isClosed()){
														s.shutdownOutput();
														s.close();
													}
												}catch(Exception exception){ exception.printStackTrace(); }
												clients.remove(s);
												return;
											}
										}
									}catch(Exception exception){ exception.printStackTrace(); }
									try{ s.close();
									}catch(Exception exception){ exception.printStackTrace(); }
									clients.remove(s);
								}
							});
							clientThread.setDaemon(true);							
							clientThread.setName("Client "+s.getInetAddress().toString());
							clientThread.start();
						}catch(SocketException e){ 
						}catch(IOException e){ e.printStackTrace(); }
					}
				}
			});
			serverThread.setDaemon(true);			
			serverThread.setName("Server");
			serverThread.start();
			
		}catch(IOException e){ 			
			e.printStackTrace(); }
	}
	//Cierra el servidor
	public void dispose(){
		open=false;
		try{ ss.close();
		}catch(IOException e){ e.printStackTrace(); }
		for(Socket s : clients){
			try{ s.close();
			}catch(Exception exception){ exception.printStackTrace(); }
		}
		clients.clear();
		clients=null;
		ss=null;
		serverListener.serverClosed();
		serverListener=null;
		
	}
	//Devuelve la ip del servidor
	public String getIp(){
		try{ ss.getInetAddress();
		return InetAddress.getLocalHost().getHostAddress();
		}catch(UnknownHostException e){ e.printStackTrace(); }
		return null;
	}
	//Mtodo para hechar a un cliente del servidor
	@SuppressWarnings("resource")public void kickClient(String ip,String puerto){
		Socket s;
		for(int i = 0; i<clients.size(); i++){
			s=clients.get(i);
			if(ip.contentEquals(s.getInetAddress().toString())&&s.getPort()==Integer.parseInt(puerto)){
				try{
					s.shutdownOutput();
					s.close();
				}catch(IOException e){ e.printStackTrace(); }
				return;
			}
		}
	}
}