package Utilidades;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;




public class GestorConexionBD {
	private String driver;	
	private String url;
	private String usuario;
	private String password;
	private Connection conexion;
	private static GestorConexionBD miGestorConexionBD;
	
	
	//Constructor
	private GestorConexionBD(){		
		inicializar();	
	}
	
	private void inicializar() {
		//Obtenemos los valores del fichero configuracin
		String v = GestorXML.getGestorXML().obtenerValorConfiguracion("baseDatos", "url");
		this.url = v;
		v = GestorXML.getGestorXML().obtenerValorConfiguracion("baseDatos", "driver");
		this.driver = v;
		v = GestorXML.getGestorXML().obtenerValorConfiguracion("baseDatos", "usuario");
		this.usuario = v;
		v = GestorXML.getGestorXML().obtenerValorConfiguracion("baseDatos", "password");
		this.password = v;
		
		//Iniciamos la conexin
		logearse();
		
	}
	//Getter
	public static GestorConexionBD getConexionBD(){
		if (miGestorConexionBD==null){
			miGestorConexionBD = new GestorConexionBD();
		}
		return miGestorConexionBD;
	}
	
	//Inicia la conexin a la base de datos
	public void logearse(){		
		
		try {
			Class.forName(driver);			
			conexion=DriverManager.getConnection(url,usuario,password);		
			conexion.setAutoCommit(true);
			conexion.createStatement();
		} catch (Exception e) {
			
			e.printStackTrace();			
		}
	}
		
	
	//Devuelve el resultado de una consulta a la BD
	public ResultSet consultaBD(String consulta) {
		ResultSet result=null;
		try{			
			Statement state = (Statement) conexion.createStatement();
			conexion.setAutoCommit(false);			
			result=(ResultSet) state.executeQuery(consulta);
			conexion.commit();			
		}
		catch(Exception e){
			e.printStackTrace();			
		}
		return result;
	}
	
	public void closeResult(ResultSet result){
		try {
			result.getStatement().getConnection().close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	//Actualiza la BD mediante una consulta
	public void actualizarBD(String sentencia){
		try{			
			Statement state=(Statement) conexion.createStatement();
			conexion.setAutoCommit(false);
			state.executeUpdate(sentencia);
			conexion.commit();			
		}catch(Exception e){
			e.printStackTrace();			
		}
	}
}