package Vista;
import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JButton;

import GestorPrincipal.GestorPrincipal;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.FlowLayout;

import javax.swing.JScrollPane;
import javax.swing.JTextPane;


public class VistaServidor extends JFrame {

	private JPanel contentPane;
	private JButton botonIniciar;
	private JPanel panel;
	private JScrollPane scrollPane;
	private JTextPane panelTexto;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					VistaServidor frame = new VistaServidor();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}	

	/**
	 * Create the frame.
	 */
	public VistaServidor() {
		setTitle("Ping-Pong Server");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);
		contentPane.add(getScrollPane(), BorderLayout.CENTER);		
		contentPane.add(getPanel(), BorderLayout.SOUTH);
	}
	
	//Muestra texto por pantalla
	public void mostrarPorPantalla(String text){
		if(panelTexto.getText().length() > 0){
			String textoActual = panelTexto.getText();
			textoActual = textoActual + "\n" + text;
			panelTexto.setText(textoActual);
		}
		else
		{
			panelTexto.setText(text);
		}
		
	}

	private JButton getBotonIniciar() {
		if (botonIniciar == null) {
			botonIniciar = new JButton("Start server");
			botonIniciar.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					iniciarConexion();
				}
			});
		}
		return botonIniciar;
	}
	
	private void iniciarConexion(){
		GestorPrincipal.getGestorPrincipal().iniciarServidor(this);
	}
	
	private JPanel getPanel() {
		if (panel == null) {
			panel = new JPanel();
			panel.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));
			panel.add(getBotonIniciar());
		}
		return panel;
	}
	private JScrollPane getScrollPane() {
		if (scrollPane == null) {
			scrollPane = new JScrollPane(getPanelTexto());
		}
		return scrollPane;
	}
	private JTextPane getPanelTexto() {
		if (panelTexto == null) {
			panelTexto = new JTextPane();
			panelTexto.setEditable(false);
		}
		return panelTexto;
	}
}
