package Modelo;


import java.sql.ResultSet;
import java.sql.SQLException;


import java.util.Properties;
import java.util.Random;


import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.PasswordAuthentication;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.AddressException;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;








import Utilidades.GestorConexionBD;

public class GestorUsuarios {
	
	public static final int ERROR_USUARIO_EXISTE = 0;
	public static final int ERROR_CORREO_EXISTE = 1;
	public static final int ERROR_CORREO_NO_VALIDO = 2;
	public static final int ERROR_CORREO_NO_EXISTE = 3;
	public static final int ERROR_CORREO_NO_ENVIADO = 4;
	public static final int ERROR_PASSWORD = 5;
	public static final int CORRECTO = 6;
	

	private static GestorUsuarios miGestorUsuarios;
	
	private Usuario usuarioActual;
	
	private GestorUsuarios() {		
	}
	
	public static GestorUsuarios getGestorUsuarios(){
		if(miGestorUsuarios == null){
			miGestorUsuarios = new GestorUsuarios();
		}
		return miGestorUsuarios;
	}
	
	public Usuario getUsuarioActual(){
		return usuarioActual;
	}
	
	//Actualiza la contrasea del usuario actual
	public void actualizarPassword(String nuevaPassword){
		String nombreUsuario = usuarioActual.getNombreUsuario();
		String consulta = "UPDATE info_jugador SET password='"+nuevaPassword+"' "
					+ "WHERE nombre_usuario='"+nombreUsuario+"';";
		GestorConexionBD.getConexionBD().actualizarBD(consulta);
	}
	//Actualiza el correo si es posible
	public int actualizarCorreo(String nuevoCorreo){
		//Comprobamos que sea valido
		boolean valido = correoValido(nuevoCorreo);
		if(!valido){
			return ERROR_CORREO_NO_VALIDO;
		}
		//Comprobamos que no este en uso por otro usuario
		String nombreUsuario = usuarioActual.getNombreUsuario();
		String consulta = "SELECT correo,nombre_usuario from info_jugador where correo='"+nuevoCorreo+"'"
				+ "AND nombre_usuario!='"+nombreUsuario+"';";
		ResultSet rs = GestorConexionBD.getConexionBD().consultaBD(consulta);
		try {
			if(rs.next()){
				return ERROR_CORREO_EXISTE;
			}
		} catch (Exception e) {			
			e.printStackTrace();
		}
		
		//Si es valido actualizamos		
		consulta = "UPDATE info_jugador SET correo='"+nuevoCorreo+"' "
				+ "WHERE nombre_usuario='"+nombreUsuario+"';";
		GestorConexionBD.getConexionBD().actualizarBD(consulta);
		return CORRECTO;
	}
	
	//Comprueba si el gameid y la password coindicen con alguna tupla de la BD
	public boolean identificarse(String userName,String password){
		boolean esta= false;
		//Realizamos la consulta
		String consulta = "SELECT nombre_usuario,password,id,correo from info_jugador where nombre_usuario='"+userName+"' and "
				+ "password='"+password+"';";
		ResultSet rs = GestorConexionBD.getConexionBD().consultaBD(consulta);
		try {
			if(rs.next()){
				esta = true;
				//Si es valido lo ponemos como usuario actual
				String correo = rs.getString("correo");
				int id = rs.getInt("id");
				usuarioActual = new Usuario(userName, correo,id);
			}
		} catch (Exception e) {			
			e.printStackTrace();
		}
		
		return esta;		
	}
	
	public int registrarse(String userName,String password,String correo){
		//Comprobamos si el correo es valido
		boolean correoValido = correoValido(correo);
		if(!correoValido){
			return ERROR_CORREO_NO_VALIDO;
		}
		//Comprobamos si existe un usuario con el mismo nombre
		boolean existeUsuario = existeUsuario(userName);
		if(existeUsuario){
			return ERROR_USUARIO_EXISTE;
		}
		//Comprobamos si el correo ya esta en uso
		boolean existeCorreo = existeCorreo(correo);
		if(existeCorreo){
			return ERROR_CORREO_EXISTE;			
		}
		//Si todo es correcto introducimos el nuevo usuario
		crearNuevoUsuario(userName,password,correo);
		return CORRECTO;
	}
	
	private void crearNuevoUsuario(String userName, String password,
			String correo) {
		//Insertamos en BD el nuevo usuario
		String consulta = "INSERT INTO info_jugador (nombre_usuario,correo,password) VALUES ("
				+ "'"+userName+"','"+correo+"','"+password+"');";
		GestorConexionBD.getConexionBD().actualizarBD(consulta);	
		//Creamos los perfiles de los juegos
		consulta = "INSERT INTO ping_pong (usuario,elo) VALUES ("
				+ "'"+userName+"',0);";
		GestorConexionBD.getConexionBD().actualizarBD(consulta);
		
		consulta = "INSERT INTO space_defense (usuario,mejor_puntuacion) VALUES ("
				+ "'"+userName+"',0);";
		GestorConexionBD.getConexionBD().actualizarBD(consulta);
	}

	//Comprueba si el correo es valido
	private boolean correoValido(String correo){
		boolean valido = true;
		InternetAddress emailAddr;
		try {
			emailAddr = new InternetAddress(correo);
			emailAddr.validate();
		} catch (AddressException e) {
			valido = false;			
		}
	    return valido;
	}
	
	private boolean existeUsuario(String userName){
		boolean esta = false;
		//Buscamos en la BD si existe el usuario
		String consulta = "SELECT nombre_usuario from info_jugador where nombre_usuario='"+userName+"';";
		ResultSet rs = GestorConexionBD.getConexionBD().consultaBD(consulta);
		try {
			if(rs.next()){
				esta = true;
			}
		} catch (Exception e) {			
			e.printStackTrace();
		}
		
		return esta;
	}
	
	private boolean existeCorreo(String correo){
		boolean esta = false;
		//Buscamos en la BD si existe el correo
		String consulta = "SELECT correo from info_jugador where correo='"+correo+"';";
		ResultSet rs = GestorConexionBD.getConexionBD().consultaBD(consulta);
		try {
			if(rs.next()){
				esta = true;
			}
		} catch (Exception e) {			
			e.printStackTrace();
		}
		
		return esta;
	}
	
	//Envia un correo al usuario registrado con el correo con la nueva password si es valido
	public int recuperarPassword(String correo){
		//Comprobamos si el correo esta en la BD
		boolean estaCorreo = existeCorreo(correo);
		if(!estaCorreo){
			//Si no esta devolvemos un error
			return ERROR_CORREO_NO_EXISTE;
		}
		//Obtenemos una password random
		String nuevaPassword = obtenerPasswordRandom();		
		//Enviamos el correo
		boolean enviado = enviarEmail(correo,nuevaPassword);
		if(enviado){
			//Actualizamos la nueva password del usuario en BD
			String consulta = "UPDATE info_jugador SET password='"+nuevaPassword+"' "
					+ "WHERE correo='"+correo+"';";
			GestorConexionBD.getConexionBD().actualizarBD(consulta);
			return CORRECTO;
		}else{
			//Devolvemos error si no se pudo enviar
			return ERROR_CORREO_NO_ENVIADO;
		}		
	}
	//Crear una password random de 8 caracteres
	private String obtenerPasswordRandom(){
		String valoresPosibles = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
		int longitud = valoresPosibles.length();
		StringBuilder sb = new StringBuilder(8);
		Random r = new Random();
		for (int i = 0; i < 8; i++) {
			sb.append(valoresPosibles.charAt(r.nextInt(longitud)));
		}
		return sb.toString();
	}
	
	private boolean enviarEmail(String correo,String passwordNueva){
		boolean enviado = true;		   
	    //Envia al email la nueva password
		String usuario = "recuperarpass1234";
		String password = "7zmWxhNZ";
		Properties props = new Properties();
		props.put("mail.smtp.host", "smtp.gmail.com");
		props.put("mail.smtp.socketFactory.port", "465");
		props.put("mail.smtp.socketFactory.class",
				"javax.net.ssl.SSLSocketFactory");
		props.put("mail.smtp.auth", "true");
		props.put("mail.smtp.port", "465");

		Session session = Session.getDefaultInstance(props,
			new javax.mail.Authenticator() {
				protected PasswordAuthentication getPasswordAuthentication() {
					return new PasswordAuthentication(usuario,password);
				}
			});

		try {
			Message message = new MimeMessage(session);
			message.setFrom(new InternetAddress(usuario));
			message.setRecipients(Message.RecipientType.TO,
					InternetAddress.parse(correo));
			message.setSubject("Recover password");
			message.setText("Your new password is: "+passwordNueva);
			Transport.send(message);
		} catch (MessagingException e) {
			enviado = false;
			e.printStackTrace();
		}
	    return enviado;
	}
	
}
