package Modelo;

import java.awt.image.BufferedImage;
import java.io.IOException;

public class Juego {

	private String nombre;
	private String pathJuego;
	private BufferedImage imagen;
	
	//Constructora
	public Juego(String nombre, String pathJuego, BufferedImage imagen) {		
		this.nombre = nombre;
		this.pathJuego = pathJuego;
		this.imagen = imagen;
	}
	
	//Getters
	public BufferedImage getImagen(){
		return imagen;
	}
	
	public String getNombre(){
		return nombre;
	}
	
	//Ejecuta el juego si es posible
	public boolean ejecutarJuego(){
		boolean b = true;
		//Obtenemos valores del usuario actual para pasar como argumentos
		GestorUsuarios gestorUsuarios = GestorUsuarios.getGestorUsuarios();
		Usuario u = gestorUsuarios.getUsuarioActual();
		int id = u.getId();
		String nombre = u.getNombreUsuario();
		System.out.println(pathJuego);
		//Ejecutamos el juego
		String comando = "java -jar \""+ pathJuego + "\" " + id + " \"" + nombre+"\"";		
		try {
			System.out.println("EJECUTANDO:"+comando);
			Runtime.getRuntime().exec(comando);			
		} catch (IOException e) {
			b = false;
			e.printStackTrace();
		}
		return b;
	}
	
	public boolean coincideNombre(String n){
		return nombre.contentEquals(n);
	}
	
	
}
