package Vistas;
import javax.swing.JPanel;

import java.awt.BorderLayout;

import javax.swing.JLabel;
import javax.swing.BoxLayout;
import javax.swing.JTextField;

import java.awt.Component;

import javax.swing.SwingConstants;

import java.awt.Dimension;

import javax.swing.JPasswordField;
import javax.swing.JButton;

import java.awt.FlowLayout;



import Modelo.GestorUsuarios;


import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.Color;


public class PanelInicioSesion extends JPanel {
	private JPanel panelSuperior;
	private JLabel lblNewLabel;
	private JPanel panelCentral;
	private JLabel lblNewLabel_1;
	private JTextField campoGameID;
	private JLabel lblNewLabel_2;
	private JPasswordField campoPassword;
	private JPanel panelInferior;
	private JButton botonInicio;
	private JLabel botonRecuperarPassword;
	private JPanel panel;

	private Controlador controlador;
	
	public PanelInicioSesion() {
		setPreferredSize(new Dimension(400, 350));
		setLayout(new BorderLayout(0, 60));
		add(getPanelSuperior(), BorderLayout.NORTH);
		add(getPanelCentral(), BorderLayout.CENTER);
		add(getPanelInferior(), BorderLayout.SOUTH);
	}
	
	private Controlador getControlador(){
		if(controlador == null){
			controlador = new Controlador();
		}
		return controlador;
	}

	private JPanel getPanelSuperior() {
		if (panelSuperior == null) {
			panelSuperior = new JPanel();
			panelSuperior.add(getLblNewLabel());
		}
		return panelSuperior;
	}
	private JLabel getLblNewLabel() {
		if (lblNewLabel == null) {
			lblNewLabel = new JLabel("LOGIN");
			lblNewLabel.setFont(new Font("Tahoma", Font.BOLD, 40));
		}
		return lblNewLabel;
	}
	private JPanel getPanelCentral() {
		if (panelCentral == null) {
			panelCentral = new JPanel();
			panelCentral.setLayout(new BoxLayout(panelCentral, BoxLayout.Y_AXIS));			
			panelCentral.add(getLblNewLabel_1());
			panelCentral.add(getCampoGameID());
			panelCentral.add(getLblNewLabel_2());
			panelCentral.add(getCampoPassword());
		}
		return panelCentral;
	}
	private JLabel getLblNewLabel_1() {
		if (lblNewLabel_1 == null) {
			lblNewLabel_1 = new JLabel("User name");
			lblNewLabel_1.setFont(new Font("Tahoma", Font.PLAIN, 20));
			lblNewLabel_1.setAlignmentX(0.1f);
		}
		return lblNewLabel_1;
	}
	private JTextField getCampoGameID() {
		if (campoGameID == null) {
			campoGameID = new JTextField();
			campoGameID.setFont(new Font("Tahoma", Font.PLAIN, 16));
			campoGameID.setHorizontalAlignment(SwingConstants.RIGHT);
			campoGameID.setColumns(30);
		}
		return campoGameID;
	}
	private JLabel getLblNewLabel_2() {
		if (lblNewLabel_2 == null) {
			lblNewLabel_2 = new JLabel("Password");
			lblNewLabel_2.setFont(new Font("Tahoma", Font.PLAIN, 20));
			lblNewLabel_2.setAlignmentX(0.1f);
		}
		return lblNewLabel_2;
	}
	private JPasswordField getCampoPassword() {
		if (campoPassword == null) {
			campoPassword = new JPasswordField();
			campoPassword.setFont(new Font("Tahoma", Font.PLAIN, 16));
			campoPassword.setHorizontalAlignment(SwingConstants.RIGHT);
			campoPassword.setColumns(30);
		}
		return campoPassword;
	}
	private JPanel getPanelInferior() {
		if (panelInferior == null) {
			panelInferior = new JPanel();
			panelInferior.setLayout(new BoxLayout(panelInferior, BoxLayout.Y_AXIS));
			panelInferior.add(getBotonInicio());
			panelInferior.add(getPanel());
		}
		return panelInferior;
	}
	private JButton getBotonInicio() {
		if (botonInicio == null) {
			botonInicio = new JButton("Login");
			botonInicio.setFont(new Font("Tahoma", Font.PLAIN, 20));
			botonInicio.setAlignmentX(Component.CENTER_ALIGNMENT);
			botonInicio.setActionCommand("login");
			botonInicio.addActionListener(getControlador());
		}
		return botonInicio;
	}
	private JLabel getBotonRecuperarPassword() {
		if (botonRecuperarPassword == null) {
			botonRecuperarPassword = new JLabel("Forgot your password?");
			botonRecuperarPassword.setForeground(Color.BLACK);
			botonRecuperarPassword.setFont(new Font("Tahoma", Font.PLAIN, 20));
			botonRecuperarPassword.setAlignmentX(Component.CENTER_ALIGNMENT);			
			botonRecuperarPassword.addMouseListener(getControlador());
		}
		return botonRecuperarPassword;
	}
	private JPanel getPanel() {
		if (panel == null) {
			panel = new JPanel();
			FlowLayout flowLayout = (FlowLayout) panel.getLayout();
			flowLayout.setVgap(20);
			panel.add(getBotonRecuperarPassword());
		}
		return panel;
	}
	
	private class Controlador implements ActionListener,MouseListener{

		//El usuario pulsa un botn de este panel
		public void actionPerformed(ActionEvent e) {
			String id = e.getActionCommand();
			if(id.contentEquals("login")){
				//Si ha pulsado login				
				//Obtenemos los datos introducidos
				String gameId = campoGameID.getText();
				String password = String.valueOf(campoPassword.getPassword());
				//Comprobamos que haya introducido datos
				if(gameId.length() > 0 && password.length() > 0){
					//Intentamos realizar el inicio sesin
					GestorUsuarios gestorUsuarios = GestorUsuarios.getGestorUsuarios();
					boolean exito = gestorUsuarios.identificarse(gameId, password);
					if(exito){
						//Cerramos esta ventana y abrimos otra nueva
						VentanaInicio.getVentanaInicio().mostrar(false);
						new VentanaMensaje("Login sucessfully.");						
						VentanaPrincipal.getVentanaPrincipal().mostrar(true);					
					}else{
						//Mostramos error
						new VentanaMensaje("User name or password incorrect.");
					}
				}else{
					//Mostramos error
					new VentanaMensaje("There are empty fields.");
				}
			}
			
		}
		//El usuario hace clic en un objeto con listener del panel
		public void mouseClicked(MouseEvent e) {
			//Comprobamos que haya hecho clic en la opcin de recuperar password
			Object o = e.getSource();
			if(o.equals(botonRecuperarPassword)){
				new VentanaRecuperarPassword();
			}
			
		}
		
		public void mouseEntered(MouseEvent e) {
			//Comprobamos que el puntero entre en un objeto del panel
			Object o = e.getSource();
			if(o.equals(botonRecuperarPassword)){
				//Cambiamos el color del texto
				botonRecuperarPassword.setForeground(Color.BLUE);
			}
		}		
		public void mouseExited(MouseEvent e) {
			//Comprobamos que el puntero salga de en un objeto del panel
			Object o = e.getSource();
			if(o.equals(botonRecuperarPassword)){
				//Cambiamos el color
				botonRecuperarPassword.setForeground(Color.BLACK);
			}
		}		
		public void mousePressed(MouseEvent e) {}		
		public void mouseReleased(MouseEvent e) {}		
	}
}
