package Vistas;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

import Modelo.GestorUsuarios;


public class PanelRegistro extends JPanel {

	private JPanel panelSuperior;
	private JLabel lblNewLabel;
	private JPanel panelCentral;
	private JLabel lblNewLabel_1;
	private JTextField campoGameID;
	private JLabel lblNewLabel_2;
	private JPasswordField campoPassword1;
	private JPanel panelInferior;
	private JButton botonRegistro;
	private JPasswordField campoPassword2;
	private JLabel label;
	private JLabel label_1;
	private JTextField campoCorreo;

	private Controlador controlador;
	
	public PanelRegistro() {
		setPreferredSize(new Dimension(400, 420));
		setLayout(new BorderLayout(0, 30));
		add(getPanelSuperior(), BorderLayout.NORTH);
		add(getPanelCentral(), BorderLayout.CENTER);
		add(getPanelInferior(), BorderLayout.SOUTH);

	}
	private Controlador getControlador(){
		if(controlador == null){
			controlador = new Controlador();
		}
		return controlador;
	}
	
	private JPanel getPanelSuperior() {
		if (panelSuperior == null) {
			panelSuperior = new JPanel();
			panelSuperior.add(getLblNewLabel());
		}
		return panelSuperior;
	}
	private JLabel getLblNewLabel() {
		if (lblNewLabel == null) {
			lblNewLabel = new JLabel("REGISTRATION");
			lblNewLabel.setFont(new Font("Tahoma", Font.BOLD, 40));
		}
		return lblNewLabel;
	}
	private JPanel getPanelCentral() {
		if (panelCentral == null) {
			panelCentral = new JPanel();
			panelCentral.setLayout(new BoxLayout(panelCentral, BoxLayout.Y_AXIS));			
			panelCentral.add(getLblNewLabel_1());
			panelCentral.add(getCampoGameID());
			panelCentral.add(getLabel_1());
			panelCentral.add(getCampoCorreo());
			panelCentral.add(getLblNewLabel_2());
			panelCentral.add(getCampoPassword1());
			panelCentral.add(getLabel());
			panelCentral.add(getCampoPassword2());
		}
		return panelCentral;
	}
	private JLabel getLblNewLabel_1() {
		if (lblNewLabel_1 == null) {
			lblNewLabel_1 = new JLabel("User name *");
			lblNewLabel_1.setFont(new Font("Tahoma", Font.PLAIN, 20));
			lblNewLabel_1.setAlignmentX(0.1f);
		}
		return lblNewLabel_1;
	}
	private JTextField getCampoGameID() {
		if (campoGameID == null) {
			campoGameID = new JTextField();
			campoGameID.setFont(new Font("Tahoma", Font.PLAIN, 16));
			campoGameID.setHorizontalAlignment(SwingConstants.RIGHT);
			campoGameID.setColumns(30);
		}
		return campoGameID;
	}
	private JLabel getLblNewLabel_2() {
		if (lblNewLabel_2 == null) {
			lblNewLabel_2 = new JLabel("Password *");
			lblNewLabel_2.setFont(new Font("Tahoma", Font.PLAIN, 20));
			lblNewLabel_2.setAlignmentX(0.1f);
		}
		return lblNewLabel_2;
	}
	private JPasswordField getCampoPassword1() {
		if (campoPassword1 == null) {
			campoPassword1 = new JPasswordField();
			campoPassword1.setFont(new Font("Tahoma", Font.PLAIN, 16));
			campoPassword1.setHorizontalAlignment(SwingConstants.RIGHT);
			campoPassword1.setColumns(30);
		}
		return campoPassword1;
	}
	private JPanel getPanelInferior() {
		if (panelInferior == null) {
			panelInferior = new JPanel();
			panelInferior.setLayout(new BoxLayout(panelInferior, BoxLayout.Y_AXIS));
			panelInferior.add(getBotonRegistro());
		}
		return panelInferior;
	}
	private JButton getBotonRegistro() {
		if (botonRegistro == null) {
			botonRegistro = new JButton("Sign in");
			botonRegistro.setFont(new Font("Tahoma", Font.PLAIN, 20));
			botonRegistro.setAlignmentX(Component.CENTER_ALIGNMENT);
			botonRegistro.setActionCommand("registrarse");
			botonRegistro.addActionListener(getControlador());
		}
		return botonRegistro;
	}


	private JPasswordField getCampoPassword2() {
		if (campoPassword2 == null) {
			campoPassword2 = new JPasswordField();
			campoPassword2.setHorizontalAlignment(SwingConstants.RIGHT);
			campoPassword2.setFont(new Font("Tahoma", Font.PLAIN, 16));
			campoPassword2.setColumns(30);
		}
		return campoPassword2;
	}
	private JLabel getLabel() {
		if (label == null) {
			label = new JLabel("Repeat password *");
			label.setFont(new Font("Tahoma", Font.PLAIN, 20));
			label.setAlignmentX(0.1f);
		}
		return label;
	}
	private JLabel getLabel_1() {
		if (label_1 == null) {
			label_1 = new JLabel("Email *");
			label_1.setFont(new Font("Tahoma", Font.PLAIN, 20));
			label_1.setAlignmentX(0.1f);
		}
		return label_1;
	}
	private JTextField getCampoCorreo() {
		if (campoCorreo == null) {
			campoCorreo = new JTextField();
			campoCorreo.setHorizontalAlignment(SwingConstants.RIGHT);
			campoCorreo.setFont(new Font("Tahoma", Font.PLAIN, 16));
			campoCorreo.setColumns(30);
		}
		return campoCorreo;
	}
	
	private class Controlador implements ActionListener{

		
		public void actionPerformed(ActionEvent e) {
			String id = e.getActionCommand();
			//Comprobamos si ha pulsado el boton registro
			if(id.contentEquals("registrarse")){
				//Obtenemos los datos introducidos
				String gameId = campoGameID.getText();
				String correo = campoCorreo.getText();
				String password1 = String.valueOf(campoPassword1.getPassword());
				String password2 = String.valueOf(campoPassword2.getPassword());
				//Comprobamos que haya introducido datos en todos los campos
				if(gameId.length() > 0 && correo.length() > 0 && password1.length() > 0 &&
						password2.length() > 0){					
					//Comprobamos que ambas password sean iguales
					if(password1.contentEquals(password2)){
						//Intentamos registrar el nuevo usuario
						GestorUsuarios gestorUsuarios = GestorUsuarios.getGestorUsuarios();
						int resultado = gestorUsuarios.registrarse(gameId, password1, correo);
						//Mostramos el mensaje en funcin del resultado
						if(resultado == GestorUsuarios.CORRECTO){
							new VentanaMensaje("New user registered.");
						}else if(resultado == GestorUsuarios.ERROR_USUARIO_EXISTE){
							new VentanaMensaje("User name already in use.");
						}else if(resultado == GestorUsuarios.ERROR_CORREO_EXISTE){
							new VentanaMensaje("Email already in use.");
						}else if(resultado == GestorUsuarios.ERROR_CORREO_NO_VALIDO){
							new VentanaMensaje("Email is not valid");
						}
					}else{
						//Si no son iguales mostramos error
						new VentanaMensaje("Passwords does not match each other.");
					}
					
				}else{
					//Si faltan datos en los campos mostramos error
					new VentanaMensaje("There are empty fields.");
				}
			}
			
		}
		
	}
}
