package Vistas;

import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;

import javax.swing.BoxLayout;
import javax.swing.JLabel;



import javax.swing.JTextField;
import javax.swing.SwingConstants;

import Modelo.GestorUsuarios;
import Modelo.Usuario;

public class VentanaCambiarEmail extends JDialog{
	private JPanel panelInferior;
	private JButton botonCambiar;	
	private Controlador controlador;
	private JPanel panelCentral;
	private JLabel lblNewLabel;
	private JTextField campoCorreo;
	private JLabel etiquetaEmailPrevio;
	
	public VentanaCambiarEmail(){
		
		setResizable(false);
		setTitle("Change email");
		setModal(true);
		setBounds(100, 100, 398, 140);
		getContentPane().add(getPanelCentral(), BorderLayout.CENTER);
		getContentPane().add(getPanelInferior(), BorderLayout.SOUTH);
		
		setLocationRelativeTo(null);
		setVisible(true);
	}
	
	private JPanel getPanelInferior() {
		if (panelInferior == null) {
			panelInferior = new JPanel();
			panelInferior.add(getBotonCambiar());
		}
		return panelInferior;
	}
	private JButton getBotonCambiar() {
		if (botonCambiar == null) {
			botonCambiar = new JButton("Change");
			botonCambiar.setActionCommand("cambiar");
			botonCambiar.addActionListener(getControlador());			
		}
		return botonCambiar;
	}
	
	private Controlador getControlador() {
		if (controlador == null) {
			controlador = new Controlador();
		}
		return controlador;
	}
	
	private JPanel getPanelCentral() {
		if (panelCentral == null) {
			panelCentral = new JPanel();
			panelCentral.setLayout(new BoxLayout(panelCentral, BoxLayout.Y_AXIS));
			panelCentral.add(getEtiquetaEmailPrevio());
			panelCentral.add(getLblNewLabel());
			panelCentral.add(getCampoCorreo());
		}
		return panelCentral;
	}
	
	private JLabel getLblNewLabel() {
		if (lblNewLabel == null) {
			lblNewLabel = new JLabel("Introduce new email");
			lblNewLabel.setFont(new Font("Tahoma", Font.PLAIN, 16));
		}
		return lblNewLabel;
	}
	private JTextField getCampoCorreo() {
		if (campoCorreo == null) {
			campoCorreo = new JTextField();
			campoCorreo.setHorizontalAlignment(SwingConstants.RIGHT);
			campoCorreo.setFont(new Font("Tahoma", Font.PLAIN, 16));
			campoCorreo.setColumns(30);
		}
		return campoCorreo;
	}
	
	private JLabel getEtiquetaEmailPrevio() {
		if (etiquetaEmailPrevio == null) {
			Usuario u = GestorUsuarios.getGestorUsuarios().getUsuarioActual();
			etiquetaEmailPrevio = new JLabel("Actual email: "+u.getCorreo());
			etiquetaEmailPrevio.setFont(new Font("Tahoma", Font.PLAIN, 16));			
		}
		return etiquetaEmailPrevio;
	}
	
	private class Controlador implements ActionListener {		

		public void actionPerformed(ActionEvent e){	
			//Si pulsa el botn de cambiar
			if(e.getActionCommand().equals("cambiar")){
				//Obtenemos el email introducido
				String correo = campoCorreo.getText();
				if(correo.length() > 0){
					//Intentamos cambiar el correo
					GestorUsuarios gestorUsuarios = GestorUsuarios.getGestorUsuarios();
					int resultado = gestorUsuarios.actualizarCorreo(correo);
					if(resultado == GestorUsuarios.CORRECTO){
						//Si se ha cambiado cerramos ventana y mostramos un mensaje de exito						
						dispose();
						new VentanaMensaje("Email changed.");
					}else if(resultado == GestorUsuarios.ERROR_CORREO_NO_VALIDO){
						//Si el correo no es valido
						new VentanaMensaje("Email is not valid.");
					}else if(resultado == GestorUsuarios.ERROR_CORREO_EXISTE){
						//Si el correo no es valido
						new VentanaMensaje("Email in use.");
					}
				}else{
					//Si no ha introducido datos mostramos error
					new VentanaMensaje("You must enter an email.");
				}
			}
		}
	}
	
	
	
}
