package Vistas;

import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;

import javax.swing.BoxLayout;
import javax.swing.JLabel;




import javax.swing.SwingConstants;

import Modelo.GestorUsuarios;
import javax.swing.JPasswordField;


public class VentanaCambiarPassword extends JDialog{
	private JPanel panelInferior;
	private JButton botonCambiar;
	
	private Controlador controlador;
	private JPanel panelCentral;
	private JLabel lblNewLabel;
	private JLabel label;
	private JPasswordField campoPassword2;
	private JPasswordField campoPassword1;
	
	public VentanaCambiarPassword(){
		
		setResizable(false);
		setTitle("Change password");
		setModal(true);
		setBounds(100, 100, 398, 170);
		getContentPane().add(getPanelCentral(), BorderLayout.CENTER);
		getContentPane().add(getPanelInferior(), BorderLayout.SOUTH);
		
		setLocationRelativeTo(null);		
		setVisible(true);
	}
	
	private JPanel getPanelInferior() {
		if (panelInferior == null) {
			panelInferior = new JPanel();
			panelInferior.add(getBotonCambiar());
		}
		return panelInferior;
	}
	private JButton getBotonCambiar() {
		if (botonCambiar == null) {
			botonCambiar = new JButton("Change");
			botonCambiar.setActionCommand("cambiar");
			botonCambiar.addActionListener(getControlador());			
		}
		return botonCambiar;
	}
	
	private Controlador getControlador() {
		if (controlador == null) {
			controlador = new Controlador();
		}
		return controlador;
	}
	
	private JPanel getPanelCentral() {
		if (panelCentral == null) {
			panelCentral = new JPanel();
			panelCentral.setLayout(new BoxLayout(panelCentral, BoxLayout.Y_AXIS));
			panelCentral.add(getLblNewLabel());
			panelCentral.add(getCampoPassword1());
			panelCentral.add(getLabel());
			panelCentral.add(getCampoPassword2());
		}
		return panelCentral;
	}
	
	private JLabel getLblNewLabel() {
		if (lblNewLabel == null) {
			lblNewLabel = new JLabel("Introduce new password");
			lblNewLabel.setFont(new Font("Tahoma", Font.PLAIN, 16));
		}
		return lblNewLabel;
	}
	
	
	private JLabel getLabel() {
		if (label == null) {
			label = new JLabel("Repeat password");
			label.setHorizontalAlignment(SwingConstants.LEFT);
			label.setFont(new Font("Tahoma", Font.PLAIN, 16));
		}
		return label;
	}
	private JPasswordField getCampoPassword2() {
		if (campoPassword2 == null) {
			campoPassword2 = new JPasswordField();
			campoPassword2.setHorizontalAlignment(SwingConstants.RIGHT);
			campoPassword2.setFont(new Font("Tahoma", Font.PLAIN, 16));
		}
		return campoPassword2;
	}
	private JPasswordField getCampoPassword1() {
		if (campoPassword1 == null) {
			campoPassword1 = new JPasswordField();
			campoPassword1.setHorizontalAlignment(SwingConstants.RIGHT);
			campoPassword1.setFont(new Font("Tahoma", Font.PLAIN, 16));
		}
		return campoPassword1;
	}
	
	private class Controlador implements ActionListener {		

		public void actionPerformed(ActionEvent e){	
			//Si pulsa el botn de cambiar
			if(e.getActionCommand().equals("cambiar")){
				//Obtenemos las contraseas introducidas
				String p1 = String.valueOf(campoPassword1.getPassword());
				String p2 = String.valueOf(campoPassword2.getPassword());
				//Comprobamos que haya texto en ambas
				if(p1.length() > 0 && p2.length() > 0){
					//Comprobamos que sean iguales
					if(p1.contentEquals(p2)){
						//Actualizamos la contrasea
						GestorUsuarios gestorUsuarios = GestorUsuarios.getGestorUsuarios();
						gestorUsuarios.actualizarPassword(p1);
						//Cerramos la ventana
						dispose();
						//Mostramos un mensaje de exito
						new VentanaMensaje("Password changed.");
					}else{
						//Mostramos mensaje error
						new VentanaMensaje("Passwords do not mathc each other.");
					}					
				}else{
					//Mostramos mensaje error
					new VentanaMensaje("Fields can't be empty.");
				}
			}
		}
	}
}
