package Vistas;

import java.awt.BorderLayout;


import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import javax.swing.JTabbedPane;

public class VentanaInicio extends JFrame {

	private JPanel contentPane;	
	private JTabbedPane tabbedPane;	
	
	private static VentanaInicio miVentanaInicio;
	
	private VentanaInicio() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);
		contentPane.add(getTabbedPane(), BorderLayout.CENTER);		
		
		setResizable(false);
		setLocationRelativeTo(null);
		pack();		
	}
	
	public static VentanaInicio getVentanaInicio(){
		if(miVentanaInicio == null){
			miVentanaInicio = new VentanaInicio();
		}
		return miVentanaInicio;
	}
	
	public void mostrar(boolean b){
		setVisible(b);
		if(!b){
			dispose();
		}
	}
	

	private JTabbedPane getTabbedPane() {
		if (tabbedPane == null) {
			tabbedPane = new JTabbedPane(JTabbedPane.TOP);			
			PanelInicioSesion panelInicioSesion = new PanelInicioSesion();
			tabbedPane.addTab("Login", panelInicioSesion);			
			PanelRegistro panelRegistro = new PanelRegistro();
			tabbedPane.addTab("Registration", panelRegistro);			
		}
		return tabbedPane;
	}
	
	
}
