package Vistas;

import javax.swing.JDialog;
import javax.swing.JPanel;


import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


import javax.swing.JButton;

import javax.swing.JTextPane;
import java.awt.Font;

public class VentanaMensaje extends JDialog {
	private JPanel panelInferior;
	private JButton botonOK;
	private String mensaje;
	private Controlador controlador;
	private JPanel panelCentral;
	private JTextPane panelTexto;

	public VentanaMensaje(String mensaje) {
		this.mensaje = mensaje;
		setResizable(false);		
		setModal(true);
		setBounds(100, 100, 398, 150);
		getContentPane().add(getPanelCentral(), BorderLayout.CENTER);
		getContentPane().add(getPanelInferior(), BorderLayout.SOUTH);
		
		setLocationRelativeTo(null);
		setVisible(true);
	}
	
	private JPanel getPanelInferior() {
		if (panelInferior == null) {
			panelInferior = new JPanel();
			panelInferior.add(getBotonOK());
		}
		return panelInferior;
	}
	private JButton getBotonOK() {
		if (botonOK == null) {
			botonOK = new JButton("OK");
			botonOK.setActionCommand("OK");
			botonOK.addActionListener(getControlador());
		}
		return botonOK;
	}
	
	private Controlador getControlador() {
		if (controlador == null) {
			controlador = new Controlador();
		}
		return controlador;
	}
	
	private JPanel getPanelCentral() {
		if (panelCentral == null) {
			panelCentral = new JPanel();
			panelCentral.add(getPanelTexto());
		}
		return panelCentral;
	}
	private JTextPane getPanelTexto() {
		if (panelTexto == null) {
			panelTexto = new JTextPane();
			panelTexto.setFont(new Font("Tahoma", Font.BOLD, 16));
			panelTexto.setEditable(false);
			
			panelTexto.setText(mensaje);
		}
		return panelTexto;
	}
	
	private class Controlador implements ActionListener {		

		public void actionPerformed(ActionEvent e){	
			//Si pulsa OK cerramos
			if(e.getActionCommand().equals("OK")){
				dispose();
			}
		}
	}
	
}