package Vistas;

import java.awt.BorderLayout;


import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import javax.swing.ImageIcon;

import javax.swing.JMenuBar;

import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JList;
import javax.swing.AbstractListModel;
import javax.swing.border.LineBorder;

import java.awt.Color;



import java.awt.Component;
import java.awt.Dimension;

import javax.swing.border.BevelBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import Modelo.GestorJuegos;


import javax.swing.JMenu;
import javax.swing.SwingConstants;


import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;

import javax.swing.JMenuItem;

import java.awt.FlowLayout;

public class VentanaPrincipal extends JFrame {

	private JPanel contentPane;
	private JPanel panelMenu;
	private JPanel panelCentral;
	private JPanel panelIzquierda;
	private JLabel imagenJuego;
	private JButton botonJugar;
	private JList listaJuegos;
	
	private AbstractListModel listado;
	
	private static VentanaPrincipal miVentanaPrincipal;
	private JMenuBar menuBar;
	private JMenu menuProfile;
	private JMenuItem menuCambiarCorreo;
	private JMenuItem menuCambiarPassword;
	
	private Controlador controlador;
	private JMenuItem menuSalir;

	private VentanaPrincipal() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(5, 5));
		setContentPane(contentPane);
		contentPane.add(getPanelMenu(), BorderLayout.NORTH);
		contentPane.add(getPanel_1(), BorderLayout.CENTER);
		contentPane.add(getPanel_2(), BorderLayout.WEST);	
		
		setResizable(false);
		setLocationRelativeTo(null);
		pack();
	}	
	
	public static VentanaPrincipal getVentanaPrincipal(){
		if(miVentanaPrincipal == null){
			miVentanaPrincipal = new VentanaPrincipal();
		}
		return miVentanaPrincipal;
	}
	
	private Controlador getControlador(){
		if(controlador == null){
			controlador = new Controlador();
		}
		return controlador;
	}
	
	public void mostrar(boolean b){
		setVisible(b);
		if(!b){
			dispose();
		}
	}
	
	private JPanel getPanelMenu() {
		if (panelMenu == null) {
			panelMenu = new JPanel();
			FlowLayout fl_panelMenu = new FlowLayout(FlowLayout.LEFT, 5, 5);
			panelMenu.setLayout(fl_panelMenu);
			panelMenu.add(getMenuBar_1());
		}
		return panelMenu;
	}
	private JPanel getPanel_1() {
		if (panelCentral == null) {
			panelCentral = new JPanel();
			panelCentral.setLayout(new BorderLayout(5, 5));
			panelCentral.add(getImagenJuego(), BorderLayout.CENTER);
			panelCentral.add(getBotonJugar(), BorderLayout.SOUTH);
		}
		return panelCentral;
	}
	private JPanel getPanel_2() {
		if (panelIzquierda == null) {
			panelIzquierda = new JPanel();
			panelIzquierda.setPreferredSize(new Dimension(120, 400));
			panelIzquierda.setLayout(new BorderLayout(0, 0));
			panelIzquierda.add(getListaJuegos());
		}
		return panelIzquierda;
	}
	private JLabel getImagenJuego() {
		if (imagenJuego == null) {
			imagenJuego = new JLabel("");
			imagenJuego.setBorder(new LineBorder(new Color(0, 0, 0)));
			imagenJuego.setPreferredSize(new Dimension(600, 400));
		}
		return imagenJuego;
	}
	private JButton getBotonJugar() {
		if (botonJugar == null) {
			botonJugar = new JButton("Play");
			botonJugar.setActionCommand("play");
			botonJugar.addActionListener(getControlador());
		}
		return botonJugar;
	}
	private JList getListaJuegos() {
		if (listaJuegos == null) {
			listaJuegos = new JList();
			listaJuegos.setLayoutOrientation(JList.VERTICAL_WRAP);
			listaJuegos.setVisibleRowCount(30);
			listaJuegos.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
			String[] lista = GestorJuegos.getGestorJuegos().getNombreJuegos();	
			listado = new AbstractListModel() {
				String[] values = lista;					
				public int getSize() {
					return values.length;
				}
				public Object getElementAt(int index) {
					return values[index];
				}
			};
			listaJuegos.setModel(listado);
			listaJuegos.addListSelectionListener(getControlador());
			listaJuegos.setSelectedIndex(0);
		}
		return listaJuegos;
	}
	private JMenuBar getMenuBar_1() {
		if (menuBar == null) {
			menuBar = new JMenuBar();
			menuBar.setAlignmentX(Component.LEFT_ALIGNMENT);
			menuBar.add(getMenuProfile());
			menuBar.add(getMenuSalir());
		}
		return menuBar;
	}
	private JMenu getMenuProfile() {
		if (menuProfile == null) {
			menuProfile = new JMenu("Profile");
			menuProfile.setAlignmentX(Component.LEFT_ALIGNMENT);
			menuProfile.setHorizontalAlignment(SwingConstants.LEFT);
			menuProfile.add(getMenuCambiarCorreo());
			menuProfile.add(getMenuCambiarPassword());
		}
		return menuProfile;
	}
	private JMenuItem getMenuCambiarCorreo() {
		if (menuCambiarCorreo == null) {
			menuCambiarCorreo = new JMenuItem("Change email");
			menuCambiarCorreo.setActionCommand("cambiarCorreo");
			menuCambiarCorreo.addActionListener(getControlador());
		}
		return menuCambiarCorreo;
	}
	private JMenuItem getMenuCambiarPassword() {
		if (menuCambiarPassword == null) {
			menuCambiarPassword = new JMenuItem("Change password");
			menuCambiarPassword.setActionCommand("cambiarPassword");
			menuCambiarPassword.addActionListener(getControlador());
		}
		return menuCambiarPassword;
	}
	
	private JMenuItem getMenuSalir() {
		if (menuSalir == null) {
			menuSalir = new JMenuItem("Log out");
			menuSalir.setAlignmentX(Component.LEFT_ALIGNMENT);
			menuSalir.setActionCommand("salir");
			menuSalir.addActionListener(getControlador());
		}
		return menuSalir;
	}
	
	private class Controlador implements ActionListener, ListSelectionListener{

		//El usuario pulsa un botn de la interfaz
		public void actionPerformed(ActionEvent e) {
			String id = e.getActionCommand();			
			//Comprobamos cual ha pulsado
			if(id.contentEquals("cambiarCorreo")){
				new VentanaCambiarEmail();
			}else if(id.contentEquals("cambiarPassword")){
				new VentanaCambiarPassword();
			}else if(id.contentEquals("play")){
				//Obtenemos el juego seleccionado
				String nombreJuego = (String) listado.getElementAt(listaJuegos.getSelectedIndex());
				//Ejecutamos el juego
				GestorJuegos gestorJuegos = GestorJuegos.getGestorJuegos();
				gestorJuegos.ejecutarJuego(nombreJuego);
			}else if(id.contentEquals("salir")){
				//Cerramos la ventana y abrimos la inicial
				mostrar(false);
				VentanaInicio.getVentanaInicio().mostrar(true);
			}
		}

		//El usuario selecciona un juego de la lista
		public void valueChanged(ListSelectionEvent e) {
			//Obtenemos el juego seleccionado
			String nombreJuego = (String) listado.getElementAt(listaJuegos.getSelectedIndex());
			//Obtenemos la imagen del juego y la ponemos en pantalla
			GestorJuegos gestorJuegos = GestorJuegos.getGestorJuegos();
			BufferedImage imagen = gestorJuegos.getImagenJuego(nombreJuego);
			imagenJuego.setIcon(new ImageIcon(imagen));
		}
		
	}
	
	
}
