package Vistas;

import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;

import javax.swing.BoxLayout;
import javax.swing.JLabel;



import javax.swing.JTextField;
import javax.swing.SwingConstants;

import Modelo.GestorUsuarios;

public class VentanaRecuperarPassword extends JDialog{
	private JPanel panelInferior;
	private JButton botonRecuperar;
	
	private Controlador controlador;
	private JPanel panelCentral;
	private JLabel lblNewLabel;
	private JTextField campoCorreo;
	
	public VentanaRecuperarPassword(){
		
		setResizable(false);
		setTitle("Recover password");
		setModal(true);
		setBounds(100, 100, 398, 120);
		getContentPane().add(getPanelCentral(), BorderLayout.CENTER);
		getContentPane().add(getPanelInferior(), BorderLayout.SOUTH);
		
		setLocationRelativeTo(null);
		setVisible(true);
	}
	
	private JPanel getPanelInferior() {
		if (panelInferior == null) {
			panelInferior = new JPanel();
			panelInferior.add(getBotonRecuperar());
		}
		return panelInferior;
	}
	private JButton getBotonRecuperar() {
		if (botonRecuperar == null) {
			botonRecuperar = new JButton("Recover");
			botonRecuperar.setActionCommand("recuperar");
			botonRecuperar.addActionListener(getControlador());			
		}
		return botonRecuperar;
	}
	
	private Controlador getControlador() {
		if (controlador == null) {
			controlador = new Controlador();
		}
		return controlador;
	}
	
	private JPanel getPanelCentral() {
		if (panelCentral == null) {
			panelCentral = new JPanel();
			panelCentral.setLayout(new BoxLayout(panelCentral, BoxLayout.Y_AXIS));
			panelCentral.add(getLblNewLabel());
			panelCentral.add(getCampoCorreo());
		}
		return panelCentral;
	}
	
	private JLabel getLblNewLabel() {
		if (lblNewLabel == null) {
			lblNewLabel = new JLabel("Introduce the email you register with.");
			lblNewLabel.setFont(new Font("Tahoma", Font.PLAIN, 16));
		}
		return lblNewLabel;
	}
	private JTextField getCampoCorreo() {
		if (campoCorreo == null) {
			campoCorreo = new JTextField();
			campoCorreo.setHorizontalAlignment(SwingConstants.RIGHT);
			campoCorreo.setFont(new Font("Tahoma", Font.PLAIN, 16));
			campoCorreo.setColumns(30);
		}
		return campoCorreo;
	}
	
	private class Controlador implements ActionListener {		

		public void actionPerformed(ActionEvent e){	
			//Si pulsa el botn de recover
			if(e.getActionCommand().equals("recuperar")){
				//Obtenemos el email introducido
				String correo = campoCorreo.getText();
				if(correo.length() > 0){
					//Intentamos recuperar la password
					GestorUsuarios gestorUsuarios = GestorUsuarios.getGestorUsuarios();
					int resultado = gestorUsuarios.recuperarPassword(correo);
					if(resultado == GestorUsuarios.CORRECTO){
						//Si se ha enviado mostramos un mensaje
						new VentanaMensaje("Email sent successfully.");
						//Cerramos esta ventana
						dispose();
					}else if(resultado == GestorUsuarios.ERROR_CORREO_NO_EXISTE){
						//Si el correo no esta en BD
						new VentanaMensaje("Email not registered.");
					}else if(resultado == GestorUsuarios.ERROR_CORREO_NO_VALIDO){
						//Si el correo no se pudo enviar
						new VentanaMensaje("Could not sent the email.");
					}
				}else{
					//Si no ha introducido datos mostramos error
					new VentanaMensaje("You must enter an email.");
				}
			}
		}
	}
	
	
}
