package SpaceInvaders.Estados;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.util.ArrayList;

import SpaceInvaders.GestorJuego.GestorPrincipal;
import SpaceInvaders.InferfazUsuario.BotonInterfaz;
import SpaceInvaders.InferfazUsuario.IUIListener;
import SpaceInvaders.InferfazUsuario.IconoSonido;
import SpaceInvaders.InferfazUsuario.Imagen;
import SpaceInvaders.InferfazUsuario.Texto;
import SpaceInvaders.InferfazUsuario.UIObject;
import SpaceInvaders.InferfazUsuario.UIObjectInteractive;
import SpaceInvaders.Sonido.GestorSonido;
import SpaceInvaders.Utilidades.GestorUsuarios;

public class EstadoFinPartida implements IState,IUIListener{

	//Componentes para pintar la pantalla
	private ArrayList<UIObject> listaObjetosInterfaz;
	
	public EstadoFinPartida(int puntuacion) {
		listaObjetosInterfaz = new ArrayList<UIObject>();
		
		//Creamos los objetos de la interfaz
		//Creamos el fondo
		Dimension d = GestorPrincipal.getGestorPrincipal().getDimensionPantalla();		
	
		Imagen fondo = new Imagen(0, 0, (int)d.getWidth(),(int)d.getHeight(), "/Imagenes/background.png");
		listaObjetosInterfaz.add(fondo);
		
		//Creamos los botones
		BotonInterfaz b1 = new BotonInterfaz(250, 550, "jugar", "PLAY AGAIN",30);
		b1.addListener(this);
		listaObjetosInterfaz.add(b1);
		
		BotonInterfaz b2 = new BotonInterfaz(250, 600, "menu", "MAIN MENU",30);
		b2.addListener(this);
		listaObjetosInterfaz.add(b2);		
		
		
		//Ponemos ttulo
		Texto t = new Texto(250, 120, "GAME", Texto.CENTER_ALIGNMENT, false, Color.green, 60);
		listaObjetosInterfaz.add(t);
		Texto t2 = new Texto(250, 190, "OVER", Texto.CENTER_ALIGNMENT, false, Color.green, 60);
		listaObjetosInterfaz.add(t2);
		
		//Ponemos la puntuacin obtenida
		Texto t3 = new Texto(250, 300, "SCORE", Texto.CENTER_ALIGNMENT, false, Color.WHITE, 40);
		listaObjetosInterfaz.add(t3);
		Texto t4 = new Texto(250, 360, String.valueOf(puntuacion), Texto.CENTER_ALIGNMENT, false, Color.WHITE, 40);
		listaObjetosInterfaz.add(t4);
		//Si es mejor ponemos texto parpadenate
		boolean mejor = GestorUsuarios.getGestorUsuarios().getUsuarioActual().setMejorPuntuacion(puntuacion);
		if(mejor){
			Texto t5 = new Texto(250, 420,"NEW BEST SCORE" , Texto.CENTER_ALIGNMENT, true, Color.red, 40);
			listaObjetosInterfaz.add(t5);
		}		
		
		//Creamos el icono de sonido
		IconoSonido is = new IconoSonido(460, 660, "sonido", 30, 30);
		is.addListener(this);
		listaObjetosInterfaz.add(is);
		
	}
	
	public void onSet() {
		GestorSonido.getGestorSonido().ponerMusica(GestorSonido.MUSICA_GAME_OVER);
	}
	public void onChange() {
		GestorSonido.getGestorSonido().detenerMusica();
	}
	
	public void update() {
		for (UIObject o: listaObjetosInterfaz) {
			o.update();
		}		
	}	
	
	public void render(Graphics g) {		
		for (UIObject o : listaObjetosInterfaz) {
			o.draw(g);
		}
	}
	
	public void interaccion(UIObjectInteractive object) {
		String id = object.getIdentificador();
		if(id.contentEquals("jugar")){				
			GestorPrincipal.getGestorPrincipal().iniciarNuevaPartida();
		}else if(id.contentEquals("menu")){			
			GestorPrincipal.getGestorPrincipal().cambiarEstado(StateMachine.MENU_INICIO);
		}else if(id.contentEquals("sonido")){
			GestorSonido.getGestorSonido().ponerMusica(GestorSonido.MUSICA_GAME_OVER);
		}
	}

}
