package SpaceInvaders.Estados;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.util.ArrayList;

import SpaceInvaders.GestorJuego.GestorPrincipal;
import SpaceInvaders.InferfazUsuario.BotonInterfaz;
import SpaceInvaders.InferfazUsuario.IUIListener;
import SpaceInvaders.InferfazUsuario.IconoSonido;
import SpaceInvaders.InferfazUsuario.Imagen;
import SpaceInvaders.InferfazUsuario.Texto;
import SpaceInvaders.InferfazUsuario.UIObject;
import SpaceInvaders.InferfazUsuario.UIObjectInteractive;


public class EstadoInstrucciones implements IState,IUIListener {
	
	private ArrayList<UIObject> listaObjetosInterfaz;
	
	//Constructor
	public EstadoInstrucciones() {
		crearInterfaz();
	}
	
	private void crearInterfaz() {
		listaObjetosInterfaz = new ArrayList<UIObject>();
		//Creamos el fondo
		Dimension d = GestorPrincipal.getGestorPrincipal().getDimensionPantalla();			
		Imagen fondo = new Imagen(0, 0, (int)d.getWidth(),(int)d.getHeight(), "/Imagenes/background.png");
		listaObjetosInterfaz.add(fondo);
		
		//Ttulo
		Texto t = new Texto(250, 120, "INSTRUCTIONS", Texto.CENTER_ALIGNMENT, false, Color.GREEN, 60);
		listaObjetosInterfaz.add(t);
		
		//Botones
		BotonInterfaz bi = new BotonInterfaz(250, 650, "atras", "BACK",30);
		bi.addListener(this);
		listaObjetosInterfaz.add(bi);
		
		//Creamos el icono de sonido
		IconoSonido is = new IconoSonido(460, 660, "sonido", 30, 30);
		is.addListener(this);
		listaObjetosInterfaz.add(is);
		
		//Creamos la parte de controles 
		t = new Texto(30, 170, "CONTROLS", Texto.LEFT_ALIGNMENT, false, Color.orange, 30);
		listaObjetosInterfaz.add(t);
		
		Imagen i = new Imagen(30, 170, 50, 50, "/Imagenes/IconoBotonA.png");
		listaObjetosInterfaz.add(i);
		i = new Imagen(60, 170, 50, 50, "/Imagenes/IconoBotonD.png");
		listaObjetosInterfaz.add(i);
		t = new Texto(110, 200, "Move left/right", Texto.LEFT_ALIGNMENT, false, Color.WHITE, 15);
		listaObjetosInterfaz.add(t);
		
		i = new Imagen(30, 210, 50, 50, "/Imagenes/IconoBotonP.png");
		listaObjetosInterfaz.add(i);
		t = new Texto(80, 240, "Pause/Resume", Texto.LEFT_ALIGNMENT, false, Color.WHITE, 15);
		listaObjetosInterfaz.add(t);
		
		i = new Imagen(280, 170, 50, 50, "/Imagenes/IconoRaton.png");
		listaObjetosInterfaz.add(i);
		t = new Texto(340, 200, "Shoot", Texto.LEFT_ALIGNMENT, false, Color.WHITE, 15);
		listaObjetosInterfaz.add(t);
		
		i = new Imagen(280, 210, 50, 50, "/Imagenes/IconoBotonEsc.png");
		listaObjetosInterfaz.add(i);
		t = new Texto(340, 240, "Exit", Texto.LEFT_ALIGNMENT, false, Color.WHITE, 15);
		listaObjetosInterfaz.add(t);
		
		//Creamos la parte reglas
		t = new Texto(30, 320, "RULES", Texto.LEFT_ALIGNMENT, false, Color.orange, 30);
		listaObjetosInterfaz.add(t);
		
		t = new Texto(30, 350, "Survive as long as possible.", Texto.LEFT_ALIGNMENT, false, Color.white, 15);
		listaObjetosInterfaz.add(t);
		
		t = new Texto(30, 390, "Get points by killing enemies.", Texto.LEFT_ALIGNMENT, false, Color.white, 15);
		listaObjetosInterfaz.add(t);
		
		t = new Texto(30, 430, "Pick up perks to get different bonuses.", Texto.LEFT_ALIGNMENT, false, Color.white, 15);
		listaObjetosInterfaz.add(t);
		
		
		
		//Creamos la parte de bonificaciones
		t = new Texto(30, 500, "PERKS", Texto.LEFT_ALIGNMENT, false, Color.orange, 30);
		listaObjetosInterfaz.add(t);
		
		i = new Imagen(30, 500, 50, 50, "/Imagenes/IconoBonificacionDisparoRapido.png");
		listaObjetosInterfaz.add(i);
		t = new Texto(80, 530, "Fast shoot", Texto.LEFT_ALIGNMENT, false, Color.WHITE, 15);
		listaObjetosInterfaz.add(t);
		
		i = new Imagen(30, 550, 50, 50, "/Imagenes/IconoBonificacionEscudo.png");
		listaObjetosInterfaz.add(i);
		t = new Texto(80, 580, "Shield", Texto.LEFT_ALIGNMENT, false, Color.WHITE, 15);
		listaObjetosInterfaz.add(t);		
		
		i = new Imagen(180, 500, 50, 50, "/Imagenes/IconoBonificacionVida.png");
		listaObjetosInterfaz.add(i);
		t = new Texto(230, 530, "+1 life", Texto.LEFT_ALIGNMENT, false, Color.WHITE, 15);
		listaObjetosInterfaz.add(t);
		
		i = new Imagen(180, 550,50, 50, "/Imagenes/IconoBonificacionTripleDisparo.png");
		listaObjetosInterfaz.add(i);
		t = new Texto(230, 580, "Triple shoot", Texto.LEFT_ALIGNMENT, false, Color.WHITE, 15);
		listaObjetosInterfaz.add(t);	
		
	}

	public void onSet() {}
	public void onChange() {}
	
	public void update() {
		for (UIObject u1 : listaObjetosInterfaz) {
			u1.update();
		}		
	}

	//Dibujo de la interfaz
	public void render(Graphics g) {
		for (UIObject u1 : listaObjetosInterfaz) {
			u1.draw(g);
		}		
	}
	//Interaccin con botones
	public void interaccion(UIObjectInteractive object) {
		String id = object.getIdentificador();
		if(id.contentEquals("atras")){				
			GestorPrincipal.getGestorPrincipal().cambiarEstado(StateMachine.MENU_INICIO);
		}		
	}
	
	

}
