package SpaceInvaders.Estados;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.util.ArrayList;

import SpaceInvaders.GestorJuego.GestorPrincipal;
import SpaceInvaders.InferfazUsuario.BotonInterfaz;
import SpaceInvaders.InferfazUsuario.IUIListener;
import SpaceInvaders.InferfazUsuario.IconoSonido;
import SpaceInvaders.InferfazUsuario.Imagen;
import SpaceInvaders.InferfazUsuario.Texto;
import SpaceInvaders.InferfazUsuario.UIObject;
import SpaceInvaders.InferfazUsuario.UIObjectInteractive;


public class EstadoMenuInicio implements IState,IUIListener {

	//Componentes para pintar la pantalla
	private ArrayList<UIObject> listaObjetosInterfaz;
	
	//Constructor
	public EstadoMenuInicio() {
		crearObjetosInterfaz();		
	}
	
	private void crearObjetosInterfaz() {		
		//Creamos los objetos de la interfaz
		listaObjetosInterfaz = new ArrayList<UIObject>();
		//Se insertan primero los objetos que irn al fondo de la interfaz que sern los que se
		//pintarn primero
		//Creamos el fondo
		Dimension d = GestorPrincipal.getGestorPrincipal().getDimensionPantalla();		
	
		Imagen fondo = new Imagen(0, 0, (int)d.getWidth(),(int)d.getHeight(), "/Imagenes/background.png");
		listaObjetosInterfaz.add(fondo);
		
		//Creamos los botones
		BotonInterfaz b1 = new BotonInterfaz(250, 300, "jugar", "PLAY",30);
		b1.addListener(this);
		listaObjetosInterfaz.add(b1);
		
		BotonInterfaz b2 = new BotonInterfaz(250, 400, "instrucciones", "INSTRUCTIONS",30);
		b2.addListener(this);
		listaObjetosInterfaz.add(b2);
		
		BotonInterfaz b3 = new BotonInterfaz(250, 500, "ranking", "RANKING",30);
		b3.addListener(this);
		listaObjetosInterfaz.add(b3);
		
		BotonInterfaz b4 = new BotonInterfaz(250, 600, "cerrar", "EXIT",30);
		b4.addListener(this);
		listaObjetosInterfaz.add(b4);	
		
		//Ponemos ttulo
		Texto t = new Texto(250, 120, "SPACE", Texto.CENTER_ALIGNMENT, false, Color.green, 60);
		listaObjetosInterfaz.add(t);
		Texto t2 = new Texto(250, 190, "DEFENSE", Texto.CENTER_ALIGNMENT, false, Color.green, 60);
		listaObjetosInterfaz.add(t2);
		
		//Creamos el icono de sonido
		IconoSonido is = new IconoSonido(460, 660, "sonido", 30, 30);
		is.addListener(this);
		listaObjetosInterfaz.add(is);
		
	}
	//Se llama al poner el estado en pantalla
	public void onSet() {}
	public void onChange() {}
	
	//Actualiza los objetos de la lista
	public void update() {		
		for (UIObject uiObject : listaObjetosInterfaz) {
			uiObject.update();
		}
	}
	//Renderiza los objetos de la lista
	public void render(Graphics g) {		
		for (UIObject uiObject : listaObjetosInterfaz) {
			uiObject.draw(g);
		}
	}
	
	//Gestion de los eventos sobre los objetos de la interfaz
	public void interaccion(UIObjectInteractive object) {
		String id = object.getIdentificador();
		if(id.contentEquals("jugar")){			
			GestorPrincipal.getGestorPrincipal().iniciarNuevaPartida();
		}else if(id.contentEquals("instrucciones")){			
			GestorPrincipal.getGestorPrincipal().cambiarEstado(StateMachine.INSTRUCCIONES);
		}else if(id.contentEquals("ranking")){
			GestorPrincipal.getGestorPrincipal().cambiarEstado(StateMachine.VER_RANKING);
		}else if(id.contentEquals("cerrar")){
			GestorPrincipal.getGestorPrincipal().cerrarJuego();
		}
	}
	
	

}
