package SpaceInvaders.Estados;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.util.ArrayList;

import SpaceInvaders.ControladoresEntrada.ControladorTeclado;
import SpaceInvaders.GestorJuego.GestorPrincipal;

import SpaceInvaders.InferfazUsuario.IUIListener;
import SpaceInvaders.InferfazUsuario.IconoSonido;
import SpaceInvaders.InferfazUsuario.Imagen;
import SpaceInvaders.InferfazUsuario.Texto;
import SpaceInvaders.InferfazUsuario.UIObject;
import SpaceInvaders.InferfazUsuario.UIObjectInteractive;


public class EstadoPausa implements IState,IUIListener {

	//Componentes para pintar la pantalla
	private ArrayList<UIObject> listaObjetosInterfaz;	
	
	public EstadoPausa() {
		listaObjetosInterfaz = new ArrayList<UIObject>();		
		//Creamos los objetos de la interfaz
		//Creamos el fondo
		Dimension d = GestorPrincipal.getGestorPrincipal().getDimensionPantalla();		
	
		Imagen fondo = new Imagen(0, 0, (int)d.getWidth(),(int)d.getHeight(), "/Imagenes/background.png");
		listaObjetosInterfaz.add(fondo);		
		
		//Ponemos ttulo
		Texto t = new Texto(250, 120, "GAME", Texto.CENTER_ALIGNMENT, false, Color.green, 60);
		listaObjetosInterfaz.add(t);
		Texto t2 = new Texto(250, 190, "PAUSE", Texto.CENTER_ALIGNMENT, false, Color.green, 60);
		listaObjetosInterfaz.add(t2);
		
		//Ponemos el mensaje
		Texto t3 = new Texto(250, 400, "PRESS P TO RESUME", Texto.CENTER_ALIGNMENT, true, Color.RED, 40);
		listaObjetosInterfaz.add(t3);			
		
		//Creamos el icono de sonido
		IconoSonido is = new IconoSonido(460, 660, "sonido", 30, 30);
		is.addListener(this);
		listaObjetosInterfaz.add(is);
		
	}	
	
	public void onSet() {}
	public void onChange() {}
	
	public void update() {
		checkInputs();
		for (UIObject o : listaObjetosInterfaz) {
			o.update();			
		}
	}
	
	private void checkInputs() {
		//Comprobamos si el usuario pulsa para quitar pausa
		if(ControladorTeclado.getControladorTeclado().haSidoPulsada(ControladorTeclado.P)){
			//Volvemos a la partida
			GestorPrincipal.getGestorPrincipal().cambiarEstado(StateMachine.JUGAR);			
		}		
	}

	public void render(Graphics g) {
		for (UIObject o : listaObjetosInterfaz) {
			o.draw(g);			
		}		
	}	
	
	public void interaccion(UIObjectInteractive object) {			
	}

}
