package SpaceInvaders.GameplayObjects;

import javax.imageio.ImageIO;

import SpaceInvaders.Estados.EstadoJugar;
import SpaceInvaders.GameplayObjects.Enemigos.Enemigo;
import SpaceInvaders.GameplayObjects.Jugador.Jugador;

public class Bala extends GameObject {

	public static final int BALA_JUGADOR = 0;
	public static final int BALA_ENEMIGO = 1;
	
	private int tipo;
	
	
	public Bala(double posX, double posY,int tipo,int ancho,int alto, String pathImagen,EstadoJugar partida,
			double velocidad,double dX,double dY) {
		super(posX, posY,partida);
		this.tipo =tipo;
		this.velocidadActual = velocidad;
		this.ancho = ancho;
		this.alto = alto;		
		cargarImagen(pathImagen);
		setDireccion(dX, dY);
	}
	
	protected void cargarImagen(String path) {
		try {
			imagen = ImageIO.read(this.getClass().getResourceAsStream(path));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}	 
	
	public void update() {
		if(!fin){
			//Actualizamos posicion bala
			move();			
			//Comprobamos si colisiona
			comprobarColision();
			//Comprobamos si esta fuera de la pantalla
			fueraPantalla(partida.getDimensionPantalla());
		}
	}
	
	private void comprobarColision(){
		//Comprobamos el tipo bala
		if(tipo == BALA_JUGADOR){
			//Comprobamos colisin con enemigos			
			for (Enemigo e : partida.getListaEnemigos()) {
				boolean resultado = e.hayColision(this);
				//Si colisiona una bala del jugador matamos el enemigo y destruimos la bala
				if(resultado){
					e.kill();
					fin = true;
					break;
				}
			}							
		}else if(tipo == BALA_ENEMIGO){
			//Comprobamos colisin con jugador
			Jugador j = partida.getJugador();
			boolean resultado = j.hayColision(this);
			if(resultado){
				//Le quitamos vida
				j.quitarVida();
				fin = true;
			}							
		}
	}
	

}
