package SpaceInvaders.GameplayObjects.Bonificaciones;


import java.util.Random;



import SpaceInvaders.Estados.EstadoJugar;
import SpaceInvaders.GameplayObjects.GameObject;
import SpaceInvaders.GameplayObjects.Jugador.Jugador;
import SpaceInvaders.Utilidades.GestorXML;

public abstract class Bonificacion extends GameObject {
	
	public static final int VIDA = 0;
	public static final int TRIPLE_DISPARO = 1;
	public static final int ESCUDO = 2;	
	public static final int DISPARO_RAPIDO = 3;
	
	public static final int NUM_BONIFICACIONES = 4;
	
	protected int tipo;	
	

	public Bonificacion(double posX, double posY,EstadoJugar partida) {
		super(posX, posY,partida);		
		
		//Ponemos el tamao fijo
		String s = GestorXML.getGestorXML().obtenerValorConfiguracion("bonificacion", "size");
		this.alto = Integer.parseInt(s);
		this.ancho = Integer.parseInt(s);	
		
		cargarImagen();
		
		//Establecemos la direccin
		setDireccion(0, 1);
		
		//Establecemos velocidad random
		setVelocidadRandom();		
	}	
	
	public boolean esIgual(int tipo){
		return this.tipo == tipo;
	}
	
	public int getTipo(){
		return this.tipo;
	}	
	
	protected abstract void cargarImagen();	
	
	
	private void setVelocidadRandom(){
		//Cargamos las variables de velocidad maxima y minima
		String s = GestorXML.getGestorXML().obtenerValorConfiguracion("bonificacion", "velocidadMaxima");
		int maximo = Integer.parseInt(s);	
		s = GestorXML.getGestorXML().obtenerValorConfiguracion("bonificacion", "velocidadMinima");
		int minimo = Integer.parseInt(s);
		
		Random r = new Random();
		this.velocidadActual = minimo + (maximo - minimo) * r.nextDouble();
		
	}	
	
	private void comprobarColisionJugador(){
		Jugador j = partida.getJugador();
		boolean hayColision = hayColision(j);
		//Si hay colisin con el jugador aadimos la bonificacin
		if(hayColision){			
			j.addBonificacion(this);
			this.fin = true;
		}
	}
	
	public abstract void empezarBonificacion();	
	
	public void update() {
		if(!fin){			
			//Movemos
			move();
			//comprobar colision con jugador y fuera del tablero
			comprobarColisionJugador();
			fueraPantalla(partida.getDimensionPantalla());
		}		
	}
	

}
