package SpaceInvaders.GameplayObjects.Bonificaciones;

import java.io.IOException;

import javax.imageio.ImageIO;

import SpaceInvaders.Estados.EstadoJugar;
import SpaceInvaders.GameplayObjects.Jugador.Jugador;
import SpaceInvaders.Utilidades.GestorXML;

public class BonificacionDisparoRapido extends BonificacionTemporal {

	private long tiempoEntreDisparos;	
	
	
	public BonificacionDisparoRapido(double posX, double posY,
			EstadoJugar partida) {
		super(posX, posY, partida);
		this.tipo = Bonificacion.DISPARO_RAPIDO;		
		
		String s = GestorXML.getGestorXML().obtenerValorConfiguracion("bonificacionDisparoRapido", 
				"tiempoRecarga");
		this.tiempoEntreDisparos = Long.parseLong(s);
		
		s = GestorXML.getGestorXML().obtenerValorConfiguracion("bonificacionDisparoRapido", "duracion");
		this.duracion = Long.parseLong(s);
		
	}
	
	protected void cargarImagen() {
		try {
			this.imagen = ImageIO.read(this.getClass().getResourceAsStream("/Imagenes/IconoBonificacion"
					+ "DisparoRapido.png"));
		} catch (IOException e) {			
			e.printStackTrace();
		}		
	}
	
	public void empezarBonificacion() {
		super.empezarBonificacion();
		Jugador j = partida.getJugador();
		j.setTiempoEntreDisparos(tiempoEntreDisparos);		
	}
	
	public void finalizarBonificacion() {
		super.finalizarBonificacion();
		Jugador j = partida.getJugador();
		j.setTiempoEntreDisparosInicial();			
	}	
	
	
}
