package SpaceInvaders.GameplayObjects.Bonificaciones;

import javax.imageio.ImageIO;

import SpaceInvaders.Estados.EstadoJugar;
import SpaceInvaders.GameplayObjects.Jugador.Jugador;
import SpaceInvaders.Utilidades.GestorXML;

public class BonificacionEscudo extends BonificacionTemporal {

	public BonificacionEscudo(double posX, double posY, EstadoJugar partida) {
		super(posX, posY, partida);
		this.tipo = Bonificacion.ESCUDO;
		
		String s = GestorXML.getGestorXML().obtenerValorConfiguracion("bonificacionEscudo", "duracion");
		this.duracion = Long.parseLong(s);
	}
	
	protected void cargarImagen() {
		try {
			this.imagen = ImageIO.read(this.getClass().getResourceAsStream("/Imagenes/IconoBonificacion"
					+ "Escudo.png"));
		} catch (Exception e) {
			e.printStackTrace();
		}		
	}
	
	public void empezarBonificacion() {	
		super.empezarBonificacion();
		Jugador j = partida.getJugador();
		j.setEscudo(true);
	}
	
	public void finalizarBonificacion() {
		super.finalizarBonificacion();
		Jugador j = partida.getJugador();		
		j.setEscudo(false);
	}

}
