package SpaceInvaders.GameplayObjects.Bonificaciones;

import SpaceInvaders.Estados.EstadoJugar;

public abstract class BonificacionTemporal extends Bonificacion {

	protected boolean terminado;
	
	protected long duracion;
	protected long tiempoInicial;
	
	protected boolean iniciada;
	
	public BonificacionTemporal(double posX, double posY, EstadoJugar partida) {
		super(posX, posY, partida);
		
		terminado = false;
		iniciada = false;
	}
	
	protected void cargarImagen() {}
	
	public void empezarBonificacion() {
		iniciada = true;
		tiempoInicial = System.currentTimeMillis();
	}
	public void finalizarBonificacion(){
		terminado = true;
	}
	
	public boolean getTerminado(){
		return terminado;
	}
	
	private boolean tiempoTranscurrido(){
		return (System.currentTimeMillis() - tiempoInicial) > duracion;
	}
	
	
	public void update() {		
		super.update();
		if(!terminado && iniciada){
			//Comprobamos si ha transcurrido el tiempo
			if(tiempoTranscurrido()){				
				finalizarBonificacion();
			}
		}
	}
	
	public void reiniciar(){
		//Reiniciamos el tiempo inicio
		tiempoInicial = System.currentTimeMillis();
	}

}
