package SpaceInvaders.GameplayObjects.Bonificaciones;

import javax.imageio.ImageIO;

import SpaceInvaders.Estados.EstadoJugar;
import SpaceInvaders.GameplayObjects.Jugador.Jugador;
import SpaceInvaders.Utilidades.GestorXML;

public class BonificacionTripleDisparo extends BonificacionTemporal{

	public BonificacionTripleDisparo(double posX, double posY,
			EstadoJugar partida) {
		super(posX, posY, partida);
		this.tipo = Bonificacion.TRIPLE_DISPARO;
		
		String s = GestorXML.getGestorXML().obtenerValorConfiguracion("bonificacionTripleDisparo", "duracion");
		this.duracion = Long.parseLong(s);
	}

	
	protected void cargarImagen() {
		try {
			this.imagen = ImageIO.read(this.getClass().getResourceAsStream("/Imagenes/IconoBonificacion"
					+ "TripleDisparo.png"));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void empezarBonificacion() {	
		super.empezarBonificacion();
		Jugador j = partida.getJugador();
		j.setTripleDisparo(true);
	}
	
	public void finalizarBonificacion() {
		super.finalizarBonificacion();
		Jugador j = partida.getJugador();
		j.setTripleDisparo(false);
	}
	

}
