package SpaceInvaders.GameplayObjects.Bonificaciones;

import java.util.ArrayList;


public class GestorBonificaciones {

	private ArrayList<BonificacionTemporal> lista;
	
	//Constructor
	public GestorBonificaciones() {
		lista = new ArrayList<BonificacionTemporal>();
	}
	
	//Aade a la lista si no esta 
	public void addBonificacion(Bonificacion b) {
		//Comprobamos si es de tipo instanteno o no
		if(b instanceof BonificacionInstantanea){
			b.empezarBonificacion();
		}else
		{
			//Comprobamos si esta en la lista
			Bonificacion b2 = estaEnLista(b.tipo);			
			if(b2 == null){				
				//Si no esta aadimos
				lista.add((BonificacionTemporal) b);
				((BonificacionTemporal)b).empezarBonificacion();
			}else
			{	
				//Si esta reiniciamos
				((BonificacionTemporal)b2).reiniciar();
			}
		}		
	}
	//Devuelve la bonificacion de un tipo si esta
	private Bonificacion estaEnLista(int tipoBonificacion){
		Bonificacion bonificacion = null;
		for (Bonificacion b : lista) {
			if(b.esIgual(tipoBonificacion)){
				bonificacion = b;
				break;
			}
		}
		return bonificacion;
	}
	
	public void update(){
		//Actualiza las bonificaciones de la lista
		for (Bonificacion b : lista) {
			b.update();
		}
		//Elimina las bonificaciones terminadas
		eliminarBonificacionesTerminadas();
	}
	//Elimina de la lista las bonificaciones terminadas
	private void eliminarBonificacionesTerminadas(){
		for (int i = 0; i < lista.size(); i++) {
			BonificacionTemporal b = lista.get(i);
			if(b.getTerminado()){				
				lista.remove(b);
			}
		}
	}

}
