package SpaceInvaders.GameplayObjects.Enemigos;

import java.util.Random;

import SpaceInvaders.Estados.EstadoJugar;

import SpaceInvaders.GameplayObjects.GameObject;
import SpaceInvaders.GameplayObjects.Jugador.Jugador;

public abstract class Enemigo extends GameObject{
	
	protected double porcentajeRecompensa;
	protected int puntos;

	public Enemigo(double posX, double posY, EstadoJugar partida) {
		super(posX, posY, partida);
		setPuntos();
		setSize();
		setRandomSpeed();
		setPosicionInicial();
	}	
	
	protected double getValorRandom(double minimo ,double maximo){
		Random r = new Random();
		double num = minimo + (maximo - minimo) * r.nextDouble();
		return num;
	}
	
	//Metodo cuando muere
	public void kill(){
		//Tiramos bonificacin
		tirarBonificacion();
		//Creamos una explosin
		crearExplosion();
		//Aumentamos puntuacion jugador
		partida.getJugador().addPuntuacion(puntos);
		//Destruimos
		fin = true;
		
	}
	
	protected void comprobarColisionJugador(){
		Jugador j = partida.getJugador();
		boolean resultado = hayColision(j);
		if(resultado){
			//Si colisiona quitamos vida y destruimos el enemigo
			j.quitarVida();
			fin = true;
		}
	}
	
	protected void tirarBonificacion(){
		//Obtenemos de forma random si se tira o no una bonificacin  basandonos en el porcentaje
		Random r = new Random();
		double num = r.nextDouble();
		boolean b = false;		
		if(num >= 0.0 && num <= porcentajeRecompensa){
			b = true;
		}
		if(b){
			//Aadimos una bonificacin a la partida
			this.partida.addBonificacionRandom(this.posX, this.posY);
		}	
	}
	
	protected abstract void setPosicionInicial();
	protected abstract void setSize();
	protected abstract void setRandomSpeed();
	protected abstract void setPuntos();
	protected abstract void crearExplosion();

}
