package SpaceInvaders.GameplayObjects.Enemigos;

import java.awt.Dimension;

import SpaceInvaders.Estados.EstadoJugar;
import SpaceInvaders.GameplayObjects.Animacion;
import SpaceInvaders.GameplayObjects.Explosion;

import SpaceInvaders.GameplayObjects.Jugador.Jugador;
import SpaceInvaders.Utilidades.GestorXML;

public class EnemigoB extends Enemigo {

	private Animacion animacion;
	
	public EnemigoB(double posX, double posY,EstadoJugar partida) {
		super(posX, posY, partida);
		
		String s = GestorXML.getGestorXML().obtenerValorConfiguracion("enemigoB", "porcentajeRecompensa");
		this.porcentajeRecompensa = Double.parseDouble(s);
		//Ponemos la direccion inicial hacia abajo
		setDireccion(0, 1);			
		cargarAnimacion();
	}
	
	private void cargarAnimacion(){
		animacion = new Animacion(300L,2,"/Imagenes/Enemigo2.png");
		this.imagen = animacion.getImagen();
	}	
	
	protected void setPuntos(){
		String s = GestorXML.getGestorXML().obtenerValorConfiguracion("enemigoB","puntos");
		this.puntos = Integer.parseInt(s);
	}
	
	protected void setPosicionInicial() {
		Dimension screenSize = partida.getDimensionPantalla();
		this.posY = 0 - this.alto;
		this.posX = getValorRandom(0+this.ancho, screenSize.getWidth()-this.ancho);		
	}

	//Establecemos un tamao random
	protected void setSize() {
		String s = GestorXML.getGestorXML().obtenerValorConfiguracion("enemigoB", "maxSize");
		int max = Integer.parseInt(s);
		s = GestorXML.getGestorXML().obtenerValorConfiguracion("enemigoB", "minSize");
		int min = Integer.parseInt(s);
		int randomSize = (int) getValorRandom(min, max);
		this.ancho = randomSize;
		this.alto = randomSize;			
	}

	//Establece velocidad random
	protected void setRandomSpeed() {
		String s = GestorXML.getGestorXML().obtenerValorConfiguracion("enemigoB", "maxVelocidad");
		double maxV = Double.parseDouble(s);
		s = GestorXML.getGestorXML().obtenerValorConfiguracion("enemigoB", "minVelocidad");
		double minV = Double.parseDouble(s);
		this.velocidadActual = getValorRandom(minV, maxV);			
	}

	//Unicamente comprobamos si se va por abajo
	public void fueraPantalla(Dimension d) {
		//Comprobamos abajo
		if((posY - alto) > d.getHeight()){
			fin = true;			
			return;
		}
	}
	//Actualiza la direccion para moverse hacia el jugador
	private void actualizarDireccion() {
		Jugador j = partida.getJugador();
		//Obtenemos el vector hacia el jugador
		double vX = j.getPosicionX() - this.posX;
		double vY = j.getPosicionY() - this.posY;
		//Actualizamos la direccion
		setDireccion(vX, vY);		
	}	
	
	public void update() {
		if(!fin){
			//Actualizamos la animacion
			animacion.update();
			//Actualizamos la imagen a dibujar
			this.imagen = animacion.getImagen();
			//Actualizamos la direccion
			actualizarDireccion();
			//Movemos
			move();
			//Comprobamos colision jugador
			comprobarColisionJugador();
			//Comprobamos si estamos fuera
			fueraPantalla(partida.getDimensionPantalla());
			//Intentamos disparar		
		}
		
	}
	
	protected void crearExplosion() {
		Explosion e = new Explosion(this.posX, this.posY, partida,this.alto);
		partida.addExplosion(e);		
	}

	






	

}
