package SpaceInvaders.GameplayObjects;

import SpaceInvaders.Estados.EstadoJugar;
import SpaceInvaders.Sonido.GestorSonido;


public class Explosion extends GameObject{
	
	private Animacion animacion;

	public Explosion(double posX, double posY, EstadoJugar partida,int size) {
		super(posX, posY, partida);
		
		this.ancho = size;
		this.alto = size;
		cargarAnimacion();		
		//Ponemos sonido
		GestorSonido.getGestorSonido().playEfectoSonido(GestorSonido.EXPLOSION);
	}	

	private void cargarAnimacion() {
		animacion = new Animacion(15, 25, "/Imagenes/Explosion.png");
		this.imagen = animacion.getImagen();		
	}
	
	public void update() {
		if(!fin){
			//Actualizamos animacion e imagen
			animacion.update();
			this.imagen = animacion.getImagen();
			//Comprobamos si ya se han reproducido todos los frames
			boolean fin = animacion.getPlayedOnce();
			if(fin){
				this.fin = true;
			}		
		}		
	}

}
