package SpaceInvaders.GameplayObjects.Jugador;

import java.awt.Graphics;


import SpaceInvaders.InferfazUsuario.Imagen;
import SpaceInvaders.Utilidades.GestorXML;

public class GestorVida {

	private int vidaMaxima;
	private int vidaActual;
	
	private Imagen[] barraVida;
	
	private Jugador jugador;
	
	private boolean fin;
	
	//Constructor
	public GestorVida(Jugador j) {
		//Inicializamos variables
		String s = GestorXML.getGestorXML().obtenerValorConfiguracion("naveJugador", "vidaMaxima");
		this.vidaMaxima = Integer.parseInt(s);
		this.vidaActual = vidaMaxima;
		
		//Creamos las imagenes para mostrar la vida
		crearImagenesBarraVida();
		
		this.jugador = j;
		fin = false;
	}	
	
	private void crearImagenesBarraVida() {
		barraVida = new Imagen[vidaMaxima];
		double x = 450;
		double y = 20;
		int ancho = 20;
		int alto = 20;
		
		for (int i = 0; i < vidaMaxima; i++) {
			Imagen img = new Imagen(x, y, ancho, alto, "/Imagenes/IconoBonificacionVida.png");
			barraVida[i] = img;			
			x -= ancho*2;
		}		
	}
	
	
	public void addVida(){
		vidaActual++;
		if (vidaActual > vidaMaxima) {
			vidaActual = vidaMaxima;
		}
	}
	
	public void quitarVida(){
		if(!fin){
			vidaActual--;
			if(vidaActual == 0){
				//Si la vida llega a 0 muere
				jugador.muerto();
				fin = true;
			}
		}	
	}

	public void draw(Graphics g) {
		//Dibujamos en pantalla las vidas del jugador
		for (int i = 0; i < vidaActual; i++) {
			barraVida[i].draw(g);
		}
	}

}
