package SpaceInvaders.Utilidades;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;


public class GestorXML {

	private static GestorXML miGestorXML;
	
	private static final String PATH_CONFIGURACION = "configuracion.xml";	
	private Element documento;
	
	
	private GestorXML(){
		cargarXML();
	}
	
	public static GestorXML getGestorXML(){
		if(miGestorXML == null){
			miGestorXML = new GestorXML();
		}
		return miGestorXML;
	}
	
	
	private void cargarXML(){	
		
		try {
			//Cargamos el fichero XML desde el path predefinido
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db = dbf.newDocumentBuilder();
			Document document = db.parse(getClass().getClassLoader().getResourceAsStream(PATH_CONFIGURACION));
			
			
			//Leemos la primera etiqueta con su contenido y lo almacenamos en una variable de clase 
			Element element = document.getDocumentElement();
			this.documento = element;
			
		} catch (Exception e) {
			e.printStackTrace();
		}		
	}
	
	//Devuelve el valor de una etiqueta del fichero XML de configuracion almacenado localmente
	public String obtenerValorConfiguracion(String tipo,String nombre){
			
		//Comprobamos que el fichero XML exista
		if(documento == null){
			cargarXML();
		}		
		//Nos colocamos en la etiqueta dependiendo el tipo
		Element e = (Element)documento.getElementsByTagName(tipo).item(0);
		//Accedemos a la etiqueta dentro del tipo
		String s = e.getElementsByTagName(nombre).item(0).getTextContent();	
			
		return s;
			
	}	
}
