package SpaceInvaders.Utilidades;

import java.sql.ResultSet;

import SpaceInvaders.GestorJuego.GestorPrincipal;

public class Usuario {

	private int id;
	private String nombreUsuario;
	private int mejorPuntuacion;
	
	//Constructores
	public Usuario(int id,String nombreUsuario)throws InvalidUserException {
		
		this.nombreUsuario = nombreUsuario;
		this.id = id;
		//Lo buscamos en la BD de todos los usuarios		
		boolean existe = buscarEnBD();
		
		if(existe){
			//Buscamos en BD su mejor puntuacin
			buscarMejorPuntuacionEnBD();	
		}else
		{			
			//Lanzamos excepcion si no existe
			throw new InvalidUserException(null);
		}
	}	
	
	public Usuario(String identificador,int mejorPuntuacion){
		this.nombreUsuario = identificador;
		this.mejorPuntuacion = mejorPuntuacion;
	}
	

	//Getters
	public int getMejorPuntuacion() {
		return mejorPuntuacion;
	}
	
	public String getIdentificador() {
		return nombreUsuario;
	}	
	
	//Busca si este usuario esta en BD
	private boolean buscarEnBD(){
		
		String sql = "SELECT id,nombre_usuario FROM Info_Jugador WHERE nombre_usuario = '" + nombreUsuario + "'"
				+ " AND id =" + id +";";
		ResultSet rs = GestorConexionBD.getConexionBD().consultaBD(sql);
		try {
			if(rs.next()){
				return true;
			}else{
				return false;
			}
					
		} catch (Exception e) {
			e.printStackTrace();
			//Avisamos del error
			GestorPrincipal.getGestorPrincipal().error("Error en la conexin a la base de datos.");
			
		}
		
		return false;
		
	}
	
	//Actualiza la puntuacion si es mejor que la actual
	public boolean setMejorPuntuacion(int puntuacion) {
		//Comprobamos que sea mejor
		if(puntuacion > mejorPuntuacion){
			this.mejorPuntuacion = puntuacion;
			//Actualizamos en BD
			String sql = "UPDATE Space_Defense SET mejor_puntuacion = " + mejorPuntuacion + " WHERE "
					+ "usuario ='" + nombreUsuario + "';";			
			GestorConexionBD.getConexionBD().actualizarBD(sql);	
			return true;
		}
		return false;
	}
	//Busca en BD la mejor puntuacin de este usuario
	private void buscarMejorPuntuacionEnBD(){
		String sql = "SELECT mejor_puntuacion FROM Space_Defense WHERE usuario = '" + nombreUsuario + "';";
		ResultSet rs = GestorConexionBD.getConexionBD().consultaBD(sql);
		try {
			rs.next();
			int i = rs.getInt("mejor_puntuacion");
			this.mejorPuntuacion = i;			
		} catch (Exception e) {
			e.printStackTrace();
			//Avisamos del error
			GestorPrincipal.getGestorPrincipal().error("Error en la conexin a la base de datos.");
		}
	}
}
